/* animation.c generated by valac 0.26.1, the Vala compiler
 * generated from animation.vala, do not modify */

/*
 * Copyright (c) 2013 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>


#define POMODORO_TYPE_ANIMATION_MODE (pomodoro_animation_mode_get_type ())

#define POMODORO_TYPE_ANIMATION (pomodoro_animation_get_type ())
#define POMODORO_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_ANIMATION, PomodoroAnimation))
#define POMODORO_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_ANIMATION, PomodoroAnimationClass))
#define POMODORO_IS_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_ANIMATION))
#define POMODORO_IS_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_ANIMATION))
#define POMODORO_ANIMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_ANIMATION, PomodoroAnimationClass))

typedef struct _PomodoroAnimation PomodoroAnimation;
typedef struct _PomodoroAnimationClass PomodoroAnimationClass;
typedef struct _PomodoroAnimationPrivate PomodoroAnimationPrivate;

typedef enum  {
	POMODORO_ANIMATION_MODE_LINEAR,
	POMODORO_ANIMATION_MODE_EASE_IN,
	POMODORO_ANIMATION_MODE_EASE_OUT,
	POMODORO_ANIMATION_MODE_EASE_IN_CUBIC,
	POMODORO_ANIMATION_MODE_EASE_OUT_CUBIC,
	POMODORO_ANIMATION_MODE_EASE_IN_OUT
} PomodoroAnimationMode;

typedef gdouble (*PomodoroAnimationFunc) (gdouble progress, void* user_data);
struct _PomodoroAnimation {
	GObject parent_instance;
	PomodoroAnimationPrivate * priv;
	gdouble value_from;
	gdouble value_to;
	gdouble value;
	gdouble progress;
	guint duration;
	guint interval;
};

struct _PomodoroAnimationClass {
	GObjectClass parent_class;
	void (*destroy) (PomodoroAnimation* self);
};

struct _PomodoroAnimationPrivate {
	guint64 timestamp;
	guint timeout_id;
	PomodoroAnimationFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};


static gpointer pomodoro_animation_parent_class = NULL;

GType pomodoro_animation_mode_get_type (void) G_GNUC_CONST;
gdouble pomodoro_calculate_linear (gdouble t);
gdouble pomodoro_calculate_ease_in (gdouble t);
gdouble pomodoro_calculate_ease_out (gdouble t);
gdouble pomodoro_calculate_ease_in_cubic (gdouble t);
gdouble pomodoro_calculate_ease_out_cubic (gdouble t);
gdouble pomodoro_calculate_ease_in_out (gdouble t);
GType pomodoro_animation_get_type (void) G_GNUC_CONST;
#define POMODORO_ANIMATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_ANIMATION, PomodoroAnimationPrivate))
enum  {
	POMODORO_ANIMATION_DUMMY_PROPERTY
};
PomodoroAnimation* pomodoro_animation_new (guint duration, PomodoroAnimationMode mode);
PomodoroAnimation* pomodoro_animation_construct (GType object_type, guint duration, PomodoroAnimationMode mode);
static gdouble _pomodoro_calculate_linear_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble _pomodoro_calculate_ease_in_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble _pomodoro_calculate_ease_out_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble _pomodoro_calculate_ease_in_cubic_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble _pomodoro_calculate_ease_out_cubic_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble _pomodoro_calculate_ease_in_out_pomodoro_animation_func (gdouble progress, gpointer self);
void pomodoro_animation_stop (PomodoroAnimation* self);
gdouble pomodoro_animation_compute_value (PomodoroAnimation* self, gdouble progress);
void pomodoro_animation_update (PomodoroAnimation* self);
static gboolean pomodoro_animation_on_timeout (PomodoroAnimation* self);
void pomodoro_animation_animate_to (PomodoroAnimation* self, gdouble value_to);
static void pomodoro_animation_real_destroy (PomodoroAnimation* self);
static void pomodoro_animation_finalize (GObject* obj);


GType pomodoro_animation_mode_get_type (void) {
	static volatile gsize pomodoro_animation_mode_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_animation_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{POMODORO_ANIMATION_MODE_LINEAR, "POMODORO_ANIMATION_MODE_LINEAR", "linear"}, {POMODORO_ANIMATION_MODE_EASE_IN, "POMODORO_ANIMATION_MODE_EASE_IN", "ease-in"}, {POMODORO_ANIMATION_MODE_EASE_OUT, "POMODORO_ANIMATION_MODE_EASE_OUT", "ease-out"}, {POMODORO_ANIMATION_MODE_EASE_IN_CUBIC, "POMODORO_ANIMATION_MODE_EASE_IN_CUBIC", "ease-in-cubic"}, {POMODORO_ANIMATION_MODE_EASE_OUT_CUBIC, "POMODORO_ANIMATION_MODE_EASE_OUT_CUBIC", "ease-out-cubic"}, {POMODORO_ANIMATION_MODE_EASE_IN_OUT, "POMODORO_ANIMATION_MODE_EASE_IN_OUT", "ease-in-out"}, {0, NULL, NULL}};
		GType pomodoro_animation_mode_type_id;
		pomodoro_animation_mode_type_id = g_enum_register_static ("PomodoroAnimationMode", values);
		g_once_init_leave (&pomodoro_animation_mode_type_id__volatile, pomodoro_animation_mode_type_id);
	}
	return pomodoro_animation_mode_type_id__volatile;
}


gdouble pomodoro_calculate_linear (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	_tmp0_ = t;
	result = _tmp0_;
	return result;
}


gdouble pomodoro_calculate_ease_in (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	result = _tmp0_ * _tmp1_;
	return result;
}


gdouble pomodoro_calculate_ease_out (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	result = (2.0 - _tmp0_) * _tmp1_;
	return result;
}


gdouble pomodoro_calculate_ease_in_cubic (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	_tmp2_ = t;
	result = (_tmp0_ * _tmp1_) * _tmp2_;
	return result;
}


gdouble pomodoro_calculate_ease_out_cubic (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	_tmp2_ = t;
	result = (((_tmp0_ - 3.0) * _tmp1_) + 3.0) * _tmp2_;
	return result;
}


gdouble pomodoro_calculate_ease_in_out (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	_tmp2_ = t;
	_tmp3_ = t;
	result = ((1.0 - _tmp0_) + (2.0 - _tmp1_)) * (_tmp2_ * _tmp3_);
	return result;
}


static gdouble _pomodoro_calculate_linear_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_calculate_linear (progress);
	return result;
}


static gdouble _pomodoro_calculate_ease_in_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_calculate_ease_in (progress);
	return result;
}


static gdouble _pomodoro_calculate_ease_out_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_calculate_ease_out (progress);
	return result;
}


static gdouble _pomodoro_calculate_ease_in_cubic_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_calculate_ease_in_cubic (progress);
	return result;
}


static gdouble _pomodoro_calculate_ease_out_cubic_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_calculate_ease_out_cubic (progress);
	return result;
}


static gdouble _pomodoro_calculate_ease_in_out_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_calculate_ease_in_out (progress);
	return result;
}


PomodoroAnimation* pomodoro_animation_construct (GType object_type, guint duration, PomodoroAnimationMode mode) {
	PomodoroAnimation * self = NULL;
	guint _tmp0_ = 0U;
	PomodoroAnimationMode _tmp1_ = 0;
	self = (PomodoroAnimation*) g_object_new (object_type, NULL);
	_tmp0_ = duration;
	self->duration = _tmp0_;
	self->interval = (guint) 20;
	self->progress = 0.0;
	self->priv->timeout_id = (guint) 0;
	_tmp1_ = mode;
	switch (_tmp1_) {
		case POMODORO_ANIMATION_MODE_LINEAR:
		{
			(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
			self->priv->func = NULL;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			self->priv->func = _pomodoro_calculate_linear_pomodoro_animation_func;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			break;
		}
		case POMODORO_ANIMATION_MODE_EASE_IN:
		{
			(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
			self->priv->func = NULL;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			self->priv->func = _pomodoro_calculate_ease_in_pomodoro_animation_func;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			break;
		}
		case POMODORO_ANIMATION_MODE_EASE_OUT:
		{
			(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
			self->priv->func = NULL;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			self->priv->func = _pomodoro_calculate_ease_out_pomodoro_animation_func;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			break;
		}
		case POMODORO_ANIMATION_MODE_EASE_IN_CUBIC:
		{
			(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
			self->priv->func = NULL;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			self->priv->func = _pomodoro_calculate_ease_in_cubic_pomodoro_animation_func;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			break;
		}
		case POMODORO_ANIMATION_MODE_EASE_OUT_CUBIC:
		{
			(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
			self->priv->func = NULL;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			self->priv->func = _pomodoro_calculate_ease_out_cubic_pomodoro_animation_func;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			break;
		}
		case POMODORO_ANIMATION_MODE_EASE_IN_OUT:
		{
			(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
			self->priv->func = NULL;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			self->priv->func = _pomodoro_calculate_ease_in_out_pomodoro_animation_func;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			break;
		}
		default:
		{
			(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
			self->priv->func = NULL;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			self->priv->func = _pomodoro_calculate_linear_pomodoro_animation_func;
			self->priv->func_target = NULL;
			self->priv->func_target_destroy_notify = NULL;
			break;
		}
	}
	return self;
}


PomodoroAnimation* pomodoro_animation_new (guint duration, PomodoroAnimationMode mode) {
	return pomodoro_animation_construct (POMODORO_TYPE_ANIMATION, duration, mode);
}


void pomodoro_animation_stop (PomodoroAnimation* self) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timeout_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->timeout_id;
		g_source_remove (_tmp1_);
		self->priv->timeout_id = (guint) 0;
	}
}


gdouble pomodoro_animation_compute_value (PomodoroAnimation* self, gdouble progress) {
	gdouble result = 0.0;
	gdouble easing = 0.0;
	PomodoroAnimationFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->func;
	_tmp0__target = self->priv->func_target;
	_tmp1_ = progress;
	_tmp2_ = CLAMP (_tmp1_, 0.0, 1.0);
	_tmp3_ = _tmp0_ (_tmp2_, _tmp0__target);
	easing = _tmp3_;
	_tmp4_ = self->value_from;
	_tmp5_ = self->value_to;
	_tmp6_ = self->value_from;
	result = _tmp4_ + (easing * (_tmp5_ - _tmp6_));
	return result;
}


void pomodoro_animation_update (PomodoroAnimation* self) {
	gint64 timestamp = 0LL;
	gint64 _tmp0_ = 0LL;
	guint _tmp1_ = 0U;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_get_real_time ();
	timestamp = _tmp0_ / 1000;
	_tmp1_ = self->duration;
	if (_tmp1_ > ((guint) 0)) {
		gint64 _tmp2_ = 0LL;
		guint64 _tmp3_ = 0ULL;
		guint _tmp4_ = 0U;
		gdouble _tmp5_ = 0.0;
		_tmp2_ = timestamp;
		_tmp3_ = self->priv->timestamp;
		_tmp4_ = self->duration;
		_tmp5_ = CLAMP (((gdouble) (_tmp2_ - _tmp3_)) / ((gdouble) _tmp4_), 0.0, 1.0);
		self->progress = _tmp5_;
	} else {
		self->progress = 1.0;
	}
	_tmp6_ = self->progress;
	_tmp7_ = pomodoro_animation_compute_value (self, _tmp6_);
	self->value = _tmp7_;
	_tmp8_ = self->value;
	g_signal_emit_by_name (self, "value-changed", _tmp8_);
}


static gboolean pomodoro_animation_on_timeout (PomodoroAnimation* self) {
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, FALSE);
	pomodoro_animation_update (self);
	_tmp0_ = self->progress;
	if (_tmp0_ == 1.0) {
		pomodoro_animation_stop (self);
		g_signal_emit_by_name (self, "completed");
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


void pomodoro_animation_animate_to (PomodoroAnimation* self, gdouble value_to) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gint64 _tmp2_ = 0LL;
	guint _tmp3_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->value;
	self->value_from = _tmp0_;
	_tmp1_ = value_to;
	self->value_to = _tmp1_;
	self->progress = 0.0;
	_tmp2_ = g_get_real_time ();
	self->priv->timestamp = (guint64) (_tmp2_ / 1000);
	_tmp3_ = self->priv->timeout_id;
	if (_tmp3_ == ((guint) 0)) {
		guint _tmp4_ = 0U;
		_tmp4_ = self->duration;
		if (_tmp4_ > ((guint) 0)) {
			guint _tmp5_ = 0U;
			guint _tmp6_ = 0U;
			guint _tmp7_ = 0U;
			guint _tmp8_ = 0U;
			_tmp5_ = self->interval;
			_tmp6_ = self->duration;
			_tmp7_ = MIN (_tmp5_, _tmp6_);
			_tmp8_ = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp7_, (GSourceFunc) pomodoro_animation_on_timeout, g_object_ref (self), NULL);
			self->priv->timeout_id = _tmp8_;
		}
		g_signal_emit_by_name (self, "started");
	}
	pomodoro_animation_update (self);
}


static void pomodoro_animation_real_destroy (PomodoroAnimation* self) {
	pomodoro_animation_stop (self);
}


static void pomodoro_animation_class_init (PomodoroAnimationClass * klass) {
	pomodoro_animation_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroAnimationPrivate));
	((PomodoroAnimationClass *) klass)->destroy = pomodoro_animation_real_destroy;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_animation_finalize;
	g_signal_new ("destroy", POMODORO_TYPE_ANIMATION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroAnimationClass, destroy), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("started", POMODORO_TYPE_ANIMATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("value_changed", POMODORO_TYPE_ANIMATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	g_signal_new ("completed", POMODORO_TYPE_ANIMATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void pomodoro_animation_instance_init (PomodoroAnimation * self) {
	self->priv = POMODORO_ANIMATION_GET_PRIVATE (self);
	self->value_from = 0.0;
	self->value_to = 1.0;
	self->value = 0.0;
	self->progress = 0.0;
}


static void pomodoro_animation_finalize (GObject* obj) {
	PomodoroAnimation * self;
	guint _tmp0_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_ANIMATION, PomodoroAnimation);
	_tmp0_ = self->priv->timeout_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->timeout_id;
		g_source_remove (_tmp1_);
		self->priv->timeout_id = (guint) 0;
	}
	(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
	self->priv->func = NULL;
	self->priv->func_target = NULL;
	self->priv->func_target_destroy_notify = NULL;
	G_OBJECT_CLASS (pomodoro_animation_parent_class)->finalize (obj);
}


GType pomodoro_animation_get_type (void) {
	static volatile gsize pomodoro_animation_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_animation_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroAnimationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_animation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroAnimation), 0, (GInstanceInitFunc) pomodoro_animation_instance_init, NULL };
		GType pomodoro_animation_type_id;
		pomodoro_animation_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroAnimation", &g_define_type_info, 0);
		g_once_init_leave (&pomodoro_animation_type_id__volatile, pomodoro_animation_type_id);
	}
	return pomodoro_animation_type_id__volatile;
}



