/* skype.c generated by valac 0.26.1, the Vala compiler
 * generated from skype.vala, do not modify */

/*
 * Copyright (c) 2015 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define SKYPE_TYPE_PRESENCE_STATUS (skype_presence_status_get_type ())

#define SKYPE_TYPE_AUTHENTICATION_STATUS (skype_authentication_status_get_type ())

#define SKYPE_TYPE_API (skype_api_get_type ())
#define SKYPE_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKYPE_TYPE_API, SkypeApi))
#define SKYPE_IS_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKYPE_TYPE_API))
#define SKYPE_API_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), SKYPE_TYPE_API, SkypeApiIface))

typedef struct _SkypeApi SkypeApi;
typedef struct _SkypeApiIface SkypeApiIface;

#define SKYPE_TYPE_API_PROXY (skype_api_proxy_get_type ())
typedef GDBusProxy SkypeApiProxy;
typedef GDBusProxyClass SkypeApiProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define SKYPE_TYPE_CONNECTION (skype_connection_get_type ())
#define SKYPE_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKYPE_TYPE_CONNECTION, SkypeConnection))
#define SKYPE_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKYPE_TYPE_CONNECTION, SkypeConnectionClass))
#define SKYPE_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKYPE_TYPE_CONNECTION))
#define SKYPE_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKYPE_TYPE_CONNECTION))
#define SKYPE_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKYPE_TYPE_CONNECTION, SkypeConnectionClass))

typedef struct _SkypeConnection SkypeConnection;
typedef struct _SkypeConnectionClass SkypeConnectionClass;
typedef struct _SkypeConnectionPrivate SkypeConnectionPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SkypeConnectionAuthenticateData SkypeConnectionAuthenticateData;
typedef struct _SkypeConnectionSetStatusData SkypeConnectionSetStatusData;
typedef struct _SkypeConnectionSetAutoAwayData SkypeConnectionSetAutoAwayData;
typedef struct _SkypeConnectionResetIdleTimerData SkypeConnectionResetIdleTimerData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	SKYPE_PRESENCE_STATUS_UNKNOWN,
	SKYPE_PRESENCE_STATUS_ONLINE,
	SKYPE_PRESENCE_STATUS_OFFLINE,
	SKYPE_PRESENCE_STATUS_AWAY,
	SKYPE_PRESENCE_STATUS_NOT_AVAILABLE,
	SKYPE_PRESENCE_STATUS_DO_NOT_DISTURB,
	SKYPE_PRESENCE_STATUS_INVISIBLE,
	SKYPE_PRESENCE_STATUS_LOGGED_OUT
} SkypePresenceStatus;

typedef enum  {
	SKYPE_AUTHENTICATION_STATUS_DISCONNECTED,
	SKYPE_AUTHENTICATION_STATUS_CONNECTING,
	SKYPE_AUTHENTICATION_STATUS_CONNECTED,
	SKYPE_AUTHENTICATION_STATUS_AUTHENTICATING,
	SKYPE_AUTHENTICATION_STATUS_AUTHENTICATED
} SkypeAuthenticationStatus;

typedef enum  {
	SKYPE_ERROR_CONNECTION,
	SKYPE_ERROR_AUTHENTICATION
} SkypeError;
#define SKYPE_ERROR skype_error_quark ()
struct _SkypeApiIface {
	GTypeInterface parent_iface;
	void (*invoke) (SkypeApi* self, const gchar* request, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar* (*invoke_finish) (SkypeApi* self, GAsyncResult* _res_, GError** error);
};

struct _SkypeConnection {
	GObject parent_instance;
	SkypeConnectionPrivate * priv;
	gchar* application_name;
};

struct _SkypeConnectionClass {
	GObjectClass parent_class;
	void (*connected) (SkypeConnection* self);
	void (*disconnected) (SkypeConnection* self);
	void (*authenticated) (SkypeConnection* self);
};

struct _SkypeConnectionPrivate {
	SkypeApi* proxy;
	SkypeAuthenticationStatus status;
	guint name_watcher_id;
};

struct _SkypeConnectionAuthenticateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	SkypeConnection* self;
	gboolean _tmp0_;
	SkypeAuthenticationStatus _tmp1_;
	SkypeAuthenticationStatus _tmp2_;
	SkypeAuthenticationStatus _tmp3_;
	SkypeAuthenticationStatus _tmp4_;
	gchar* response;
	SkypeApi* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* response_type;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GQuark _tmp21_;
	gchar* _tmp22_;
	SkypeApi* _tmp23_;
	guint _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GError* _error_;
	GError* _tmp32_;
	const gchar* _tmp33_;
	GError* _tmp34_;
	GError * _inner_error_;
};

struct _SkypeConnectionSetStatusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	SkypeConnection* self;
	SkypePresenceStatus status;
	gchar* status_string;
	SkypePresenceStatus _tmp0_;
	gchar* _tmp1_;
	SkypeApi* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _error_;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GError* _tmp10_;
	GError * _inner_error_;
};

struct _SkypeConnectionSetAutoAwayData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	SkypeConnection* self;
	gboolean enabled;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gchar* enabled_string;
	gchar* _tmp2_;
	SkypeApi* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GError* _error_;
	GError* _tmp9_;
	const gchar* _tmp10_;
	GError* _tmp11_;
	GError * _inner_error_;
};

struct _SkypeConnectionResetIdleTimerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	SkypeConnection* self;
	SkypeApi* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _error_;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GError* _tmp5_;
	GError * _inner_error_;
};


static gpointer skype_connection_parent_class = NULL;
static guint skype_connection_PROTOCOL_VERSION;
static guint skype_connection_PROTOCOL_VERSION = (guint) 5;

GType skype_presence_status_get_type (void) G_GNUC_CONST;
GType skype_authentication_status_get_type (void) G_GNUC_CONST;
GQuark skype_error_quark (void);
gchar* skype_presence_status_to_string (SkypePresenceStatus presence_status);
SkypePresenceStatus skype_string_to_presence_status (const gchar* presence_status);
GType skype_api_proxy_get_type (void) G_GNUC_CONST;
guint skype_api_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType skype_api_get_type (void) G_GNUC_CONST;
void skype_api_invoke (SkypeApi* self, const gchar* request, GAsyncReadyCallback _callback_, gpointer _user_data_);
gchar* skype_api_invoke_finish (SkypeApi* self, GAsyncResult* _res_, GError** error);
static void skype_api_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data);
static void skype_api_proxy_invoke_async (SkypeApi* self, const gchar* request, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gchar* skype_api_proxy_invoke_finish (SkypeApi* self, GAsyncResult* _res_, GError** error);
static void skype_api_proxy_skype_api_interface_init (SkypeApiIface* iface);
static void _dbus_skype_api_invoke (SkypeApi* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_skype_api_invoke_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void skype_api_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* skype_api_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean skype_api_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _skype_api_unregister_object (gpointer user_data);
GType skype_connection_get_type (void) G_GNUC_CONST;
#define SKYPE_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SKYPE_TYPE_CONNECTION, SkypeConnectionPrivate))
enum  {
	SKYPE_CONNECTION_DUMMY_PROPERTY
};
SkypeConnection* skype_connection_new (const gchar* application_name);
SkypeConnection* skype_connection_construct (GType object_type, const gchar* application_name);
static void __lambda23_ (SkypeConnection* self);
void skype_connection_connect (SkypeConnection* self);
static void ___lambda23__gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self);
static void __lambda24_ (SkypeConnection* self);
void skype_connection_disconnect (SkypeConnection* self);
static void ___lambda24__gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self);
gboolean skype_connection_is_connected (SkypeConnection* self);
gboolean skype_connection_is_authenticated (SkypeConnection* self);
static gboolean skype_connection_on_authenticate_timeout (SkypeConnection* self);
void skype_connection_authenticate (SkypeConnection* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void skype_connection_authenticate_finish (SkypeConnection* self, GAsyncResult* _res_, GError** error);
static void skype_connection_authenticate_data_free (gpointer _data);
static gboolean skype_connection_authenticate_co (SkypeConnectionAuthenticateData* _data_);
static void skype_connection_authenticate_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean _skype_connection_on_authenticate_timeout_gsource_func (gpointer self);
static void skype_connection_assert_authenticated (SkypeConnection* self, GError** error);
static void skype_connection_set_status_data_free (gpointer _data);
void skype_connection_set_status (SkypeConnection* self, SkypePresenceStatus status, GAsyncReadyCallback _callback_, gpointer _user_data_);
void skype_connection_set_status_finish (SkypeConnection* self, GAsyncResult* _res_, GError** error);
static gboolean skype_connection_set_status_co (SkypeConnectionSetStatusData* _data_);
static void skype_connection_set_status_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void skype_connection_set_auto_away_data_free (gpointer _data);
void skype_connection_set_auto_away (SkypeConnection* self, gboolean enabled, GAsyncReadyCallback _callback_, gpointer _user_data_);
void skype_connection_set_auto_away_finish (SkypeConnection* self, GAsyncResult* _res_, GError** error);
static gboolean skype_connection_set_auto_away_co (SkypeConnectionSetAutoAwayData* _data_);
static void skype_connection_set_auto_away_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void skype_connection_reset_idle_timer_data_free (gpointer _data);
void skype_connection_reset_idle_timer (SkypeConnection* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void skype_connection_reset_idle_timer_finish (SkypeConnection* self, GAsyncResult* _res_, GError** error);
static gboolean skype_connection_reset_idle_timer_co (SkypeConnectionResetIdleTimerData* _data_);
static void skype_connection_reset_idle_timer_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void skype_connection_real_connected (SkypeConnection* self);
static void skype_connection_real_disconnected (SkypeConnection* self);
static void skype_connection_real_authenticated (SkypeConnection* self);
static void skype_connection_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GDBusArgInfo _skype_api_dbus_arg_info_invoke_request = {-1, "request", "s"};
static const GDBusArgInfo _skype_api_dbus_arg_info_invoke_result = {-1, "result", "s"};
static const GDBusArgInfo * const _skype_api_dbus_arg_info_invoke_in[] = {&_skype_api_dbus_arg_info_invoke_request, NULL};
static const GDBusArgInfo * const _skype_api_dbus_arg_info_invoke_out[] = {&_skype_api_dbus_arg_info_invoke_result, NULL};
static const GDBusMethodInfo _skype_api_dbus_method_info_invoke = {-1, "Invoke", (GDBusArgInfo **) (&_skype_api_dbus_arg_info_invoke_in), (GDBusArgInfo **) (&_skype_api_dbus_arg_info_invoke_out)};
static const GDBusMethodInfo * const _skype_api_dbus_method_info[] = {&_skype_api_dbus_method_info_invoke, NULL};
static const GDBusSignalInfo * const _skype_api_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _skype_api_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _skype_api_dbus_interface_info = {-1, "com.Skype.API", (GDBusMethodInfo **) (&_skype_api_dbus_method_info), (GDBusSignalInfo **) (&_skype_api_dbus_signal_info), (GDBusPropertyInfo **) (&_skype_api_dbus_property_info)};
static const GDBusInterfaceVTable _skype_api_dbus_interface_vtable = {skype_api_dbus_interface_method_call, skype_api_dbus_interface_get_property, skype_api_dbus_interface_set_property};

GType skype_presence_status_get_type (void) {
	static volatile gsize skype_presence_status_type_id__volatile = 0;
	if (g_once_init_enter (&skype_presence_status_type_id__volatile)) {
		static const GEnumValue values[] = {{SKYPE_PRESENCE_STATUS_UNKNOWN, "SKYPE_PRESENCE_STATUS_UNKNOWN", "unknown"}, {SKYPE_PRESENCE_STATUS_ONLINE, "SKYPE_PRESENCE_STATUS_ONLINE", "online"}, {SKYPE_PRESENCE_STATUS_OFFLINE, "SKYPE_PRESENCE_STATUS_OFFLINE", "offline"}, {SKYPE_PRESENCE_STATUS_AWAY, "SKYPE_PRESENCE_STATUS_AWAY", "away"}, {SKYPE_PRESENCE_STATUS_NOT_AVAILABLE, "SKYPE_PRESENCE_STATUS_NOT_AVAILABLE", "not-available"}, {SKYPE_PRESENCE_STATUS_DO_NOT_DISTURB, "SKYPE_PRESENCE_STATUS_DO_NOT_DISTURB", "do-not-disturb"}, {SKYPE_PRESENCE_STATUS_INVISIBLE, "SKYPE_PRESENCE_STATUS_INVISIBLE", "invisible"}, {SKYPE_PRESENCE_STATUS_LOGGED_OUT, "SKYPE_PRESENCE_STATUS_LOGGED_OUT", "logged-out"}, {0, NULL, NULL}};
		GType skype_presence_status_type_id;
		skype_presence_status_type_id = g_enum_register_static ("SkypePresenceStatus", values);
		g_once_init_leave (&skype_presence_status_type_id__volatile, skype_presence_status_type_id);
	}
	return skype_presence_status_type_id__volatile;
}


GType skype_authentication_status_get_type (void) {
	static volatile gsize skype_authentication_status_type_id__volatile = 0;
	if (g_once_init_enter (&skype_authentication_status_type_id__volatile)) {
		static const GEnumValue values[] = {{SKYPE_AUTHENTICATION_STATUS_DISCONNECTED, "SKYPE_AUTHENTICATION_STATUS_DISCONNECTED", "disconnected"}, {SKYPE_AUTHENTICATION_STATUS_CONNECTING, "SKYPE_AUTHENTICATION_STATUS_CONNECTING", "connecting"}, {SKYPE_AUTHENTICATION_STATUS_CONNECTED, "SKYPE_AUTHENTICATION_STATUS_CONNECTED", "connected"}, {SKYPE_AUTHENTICATION_STATUS_AUTHENTICATING, "SKYPE_AUTHENTICATION_STATUS_AUTHENTICATING", "authenticating"}, {SKYPE_AUTHENTICATION_STATUS_AUTHENTICATED, "SKYPE_AUTHENTICATION_STATUS_AUTHENTICATED", "authenticated"}, {0, NULL, NULL}};
		GType skype_authentication_status_type_id;
		skype_authentication_status_type_id = g_enum_register_static ("SkypeAuthenticationStatus", values);
		g_once_init_leave (&skype_authentication_status_type_id__volatile, skype_authentication_status_type_id);
	}
	return skype_authentication_status_type_id__volatile;
}


GQuark skype_error_quark (void) {
	return g_quark_from_static_string ("skype_error-quark");
}


gchar* skype_presence_status_to_string (SkypePresenceStatus presence_status) {
	gchar* result = NULL;
	SkypePresenceStatus _tmp0_ = 0;
	gchar* _tmp8_ = NULL;
	_tmp0_ = presence_status;
	switch (_tmp0_) {
		case SKYPE_PRESENCE_STATUS_ONLINE:
		{
			gchar* _tmp1_ = NULL;
			_tmp1_ = g_strdup ("ONLINE");
			result = _tmp1_;
			return result;
		}
		case SKYPE_PRESENCE_STATUS_OFFLINE:
		{
			gchar* _tmp2_ = NULL;
			_tmp2_ = g_strdup ("OFFLINE");
			result = _tmp2_;
			return result;
		}
		case SKYPE_PRESENCE_STATUS_AWAY:
		{
			gchar* _tmp3_ = NULL;
			_tmp3_ = g_strdup ("AWAY");
			result = _tmp3_;
			return result;
		}
		case SKYPE_PRESENCE_STATUS_NOT_AVAILABLE:
		{
			gchar* _tmp4_ = NULL;
			_tmp4_ = g_strdup ("NA");
			result = _tmp4_;
			return result;
		}
		case SKYPE_PRESENCE_STATUS_DO_NOT_DISTURB:
		{
			gchar* _tmp5_ = NULL;
			_tmp5_ = g_strdup ("DND");
			result = _tmp5_;
			return result;
		}
		case SKYPE_PRESENCE_STATUS_INVISIBLE:
		{
			gchar* _tmp6_ = NULL;
			_tmp6_ = g_strdup ("INVISIBLE");
			result = _tmp6_;
			return result;
		}
		case SKYPE_PRESENCE_STATUS_LOGGED_OUT:
		{
			gchar* _tmp7_ = NULL;
			_tmp7_ = g_strdup ("LOGGEDOUT");
			result = _tmp7_;
			return result;
		}
		default:
		break;
	}
	_tmp8_ = g_strdup ("UNKNOWN");
	result = _tmp8_;
	return result;
}


SkypePresenceStatus skype_string_to_presence_status (const gchar* presence_status) {
	SkypePresenceStatus result = 0;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	static GQuark _tmp2_label6 = 0;
	g_return_val_if_fail (presence_status != NULL, 0);
	_tmp0_ = presence_status;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("ONLINE")))) {
		switch (0) {
			default:
			{
				result = SKYPE_PRESENCE_STATUS_ONLINE;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("OFFLINE")))) {
		switch (0) {
			default:
			{
				result = SKYPE_PRESENCE_STATUS_OFFLINE;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("AWAY")))) {
		switch (0) {
			default:
			{
				result = SKYPE_PRESENCE_STATUS_AWAY;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("NA")))) {
		switch (0) {
			default:
			{
				result = SKYPE_PRESENCE_STATUS_NOT_AVAILABLE;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("DND")))) {
		switch (0) {
			default:
			{
				result = SKYPE_PRESENCE_STATUS_DO_NOT_DISTURB;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("INVISIBLE")))) {
		switch (0) {
			default:
			{
				result = SKYPE_PRESENCE_STATUS_INVISIBLE;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("LOGGEDOUT")))) {
		switch (0) {
			default:
			{
				result = SKYPE_PRESENCE_STATUS_LOGGED_OUT;
				return result;
			}
		}
	}
	result = SKYPE_PRESENCE_STATUS_UNKNOWN;
	return result;
}


void skype_api_invoke (SkypeApi* self, const gchar* request, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	SKYPE_API_GET_INTERFACE (self)->invoke (self, request, _callback_, _user_data_);
}


gchar* skype_api_invoke_finish (SkypeApi* self, GAsyncResult* _res_, GError** error) {
	return SKYPE_API_GET_INTERFACE (self)->invoke_finish (self, _res_, error);
}


static void skype_api_base_init (SkypeApiIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType skype_api_get_type (void) {
	static volatile gsize skype_api_type_id__volatile = 0;
	if (g_once_init_enter (&skype_api_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SkypeApiIface), (GBaseInitFunc) skype_api_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType skype_api_type_id;
		skype_api_type_id = g_type_register_static (G_TYPE_INTERFACE, "SkypeApi", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (skype_api_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (skype_api_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) skype_api_proxy_get_type);
		g_type_set_qdata (skype_api_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "com.Skype.API");
		g_type_set_qdata (skype_api_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_skype_api_dbus_interface_info));
		g_type_set_qdata (skype_api_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) skype_api_register_object);
		g_once_init_leave (&skype_api_type_id__volatile, skype_api_type_id);
	}
	return skype_api_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (SkypeApiProxy, skype_api_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (SKYPE_TYPE_API, skype_api_proxy_skype_api_interface_init) )
static void skype_api_proxy_class_init (SkypeApiProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = skype_api_proxy_g_signal;
}


static void skype_api_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void skype_api_proxy_init (SkypeApiProxy* self) {
}


static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data) {
	g_simple_async_result_set_op_res_gpointer (user_data, g_object_ref (res), g_object_unref);
	g_simple_async_result_complete (user_data);
	g_object_unref (user_data);
}


static void skype_api_proxy_invoke_async (SkypeApi* self, const gchar* request, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Skype.API", "Invoke");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (request));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static gchar* skype_api_proxy_invoke_finish (SkypeApi* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp49_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp49_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp49_, NULL);
	g_variant_unref (_tmp49_);
	g_object_unref (_reply_message);
	return _result;
}


static void skype_api_proxy_skype_api_interface_init (SkypeApiIface* iface) {
	iface->invoke = skype_api_proxy_invoke_async;
	iface->invoke_finish = skype_api_proxy_invoke_finish;
}


static void _dbus_skype_api_invoke (SkypeApi* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* request = NULL;
	GVariant* _tmp50_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp50_ = g_variant_iter_next_value (&_arguments_iter);
	request = g_variant_dup_string (_tmp50_, NULL);
	g_variant_unref (_tmp50_);
	skype_api_invoke (self, request, (GAsyncReadyCallback) _dbus_skype_api_invoke_ready, invocation);
	_g_free0 (request);
}


static void _dbus_skype_api_invoke_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	invocation = _user_data_;
	result = skype_api_invoke_finish ((SkypeApi*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void skype_api_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Invoke") == 0) {
		_dbus_skype_api_invoke (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* skype_api_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean skype_api_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint skype_api_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_skype_api_dbus_interface_info), &_skype_api_dbus_interface_vtable, data, _skype_api_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _skype_api_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void __lambda23_ (SkypeConnection* self) {
	skype_connection_connect (self);
}


static void ___lambda23__gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self) {
	__lambda23_ ((SkypeConnection*) self);
}


static void __lambda24_ (SkypeConnection* self) {
	skype_connection_disconnect (self);
}


static void ___lambda24__gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	__lambda24_ ((SkypeConnection*) self);
}


SkypeConnection* skype_connection_construct (GType object_type, const gchar* application_name) {
	SkypeConnection * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	g_return_val_if_fail (application_name != NULL, NULL);
	self = (SkypeConnection*) g_object_new (object_type, NULL);
	_tmp0_ = application_name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->application_name);
	self->application_name = _tmp1_;
	_g_object_unref0 (self->priv->proxy);
	self->priv->proxy = NULL;
	self->priv->status = SKYPE_AUTHENTICATION_STATUS_DISCONNECTED;
	_tmp2_ = g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, "com.Skype.API", G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((___lambda23__gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda23__gbus_name_appeared_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((___lambda24__gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda24__gbus_name_vanished_callback, g_object_ref (self), g_object_unref)));
	self->priv->name_watcher_id = _tmp2_;
	return self;
}


SkypeConnection* skype_connection_new (const gchar* application_name) {
	return skype_connection_construct (SKYPE_TYPE_CONNECTION, application_name);
}


void skype_connection_connect (SkypeConnection* self) {
	gboolean _tmp0_ = FALSE;
	SkypeApi* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->proxy;
	if (_tmp1_ == NULL) {
		SkypeAuthenticationStatus _tmp2_ = 0;
		_tmp2_ = self->priv->status;
		_tmp0_ = _tmp2_ != SKYPE_AUTHENTICATION_STATUS_CONNECTING;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		{
			SkypeApi* _tmp3_ = NULL;
			SkypeApi* _tmp4_ = NULL;
			SkypeApi* _tmp5_ = NULL;
			self->priv->status = SKYPE_AUTHENTICATION_STATUS_CONNECTING;
			_tmp4_ = g_initable_new (SKYPE_TYPE_API_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", "com.Skype.API", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/com/Skype", "g-interface-name", "com.Skype.API", "g-interface-info", g_type_get_qdata (SKYPE_TYPE_API, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
			_tmp3_ = (SkypeApi*) _tmp4_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch18_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp5_ = _tmp3_;
			_tmp3_ = NULL;
			_g_object_unref0 (self->priv->proxy);
			self->priv->proxy = _tmp5_;
			self->priv->status = SKYPE_AUTHENTICATION_STATUS_CONNECTED;
			g_signal_emit_by_name (self, "connected");
			_g_object_unref0 (_tmp3_);
		}
		goto __finally18;
		__catch18_g_io_error:
		{
			GError* _error_ = NULL;
			GError* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_tmp6_ = _error_;
			_tmp7_ = _tmp6_->message;
			g_warning ("skype.vala:163: %s", _tmp7_);
			skype_connection_disconnect (self);
			_g_error_free0 (_error_);
		}
		__finally18:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void skype_connection_disconnect (SkypeConnection* self) {
	SkypeAuthenticationStatus previous_status = 0;
	SkypeAuthenticationStatus _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	SkypeAuthenticationStatus _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->status;
	previous_status = _tmp0_;
	_g_object_unref0 (self->priv->proxy);
	self->priv->proxy = NULL;
	self->priv->status = SKYPE_AUTHENTICATION_STATUS_DISCONNECTED;
	_tmp2_ = previous_status;
	if (_tmp2_ != SKYPE_AUTHENTICATION_STATUS_DISCONNECTED) {
		SkypeAuthenticationStatus _tmp3_ = 0;
		_tmp3_ = previous_status;
		_tmp1_ = _tmp3_ != SKYPE_AUTHENTICATION_STATUS_CONNECTING;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		g_signal_emit_by_name (self, "disconnected");
	}
}


gboolean skype_connection_is_connected (SkypeConnection* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	SkypeAuthenticationStatus _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp2_ = self->priv->status;
	if (_tmp2_ == SKYPE_AUTHENTICATION_STATUS_CONNECTED) {
		_tmp1_ = TRUE;
	} else {
		SkypeAuthenticationStatus _tmp3_ = 0;
		_tmp3_ = self->priv->status;
		_tmp1_ = _tmp3_ == SKYPE_AUTHENTICATION_STATUS_AUTHENTICATING;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		SkypeAuthenticationStatus _tmp4_ = 0;
		_tmp4_ = self->priv->status;
		_tmp0_ = _tmp4_ == SKYPE_AUTHENTICATION_STATUS_AUTHENTICATED;
	}
	result = _tmp0_;
	return result;
}


gboolean skype_connection_is_authenticated (SkypeConnection* self) {
	gboolean result = FALSE;
	SkypeAuthenticationStatus _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->status;
	result = _tmp0_ == SKYPE_AUTHENTICATION_STATUS_AUTHENTICATED;
	return result;
}


static gboolean skype_connection_on_authenticate_timeout (SkypeConnection* self) {
	gboolean result = FALSE;
	SkypeAuthenticationStatus _tmp0_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->status;
	if (_tmp0_ == SKYPE_AUTHENTICATION_STATUS_AUTHENTICATING) {
		{
			self->priv->status = SKYPE_AUTHENTICATION_STATUS_CONNECTED;
			skype_connection_authenticate (self, NULL, NULL);
		}
		goto __finally19;
		__catch19_g_io_error:
		{
			GError* _error_ = NULL;
			GError* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_tmp1_ = _error_;
			_tmp2_ = _tmp1_->message;
			g_warning ("skype.vala:206: %s", _tmp2_);
			_g_error_free0 (_error_);
		}
		__finally19:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = FALSE;
	return result;
}


static void skype_connection_authenticate_data_free (gpointer _data) {
	SkypeConnectionAuthenticateData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SkypeConnectionAuthenticateData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void skype_connection_authenticate (SkypeConnection* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	SkypeConnectionAuthenticateData* _data_;
	SkypeConnection* _tmp0_ = NULL;
	_data_ = g_slice_new0 (SkypeConnectionAuthenticateData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, skype_connection_authenticate);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, skype_connection_authenticate_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	skype_connection_authenticate_co (_data_);
}


void skype_connection_authenticate_finish (SkypeConnection* self, GAsyncResult* _res_, GError** error) {
	SkypeConnectionAuthenticateData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void skype_connection_authenticate_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	SkypeConnectionAuthenticateData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	skype_connection_authenticate_co (_data_);
}


static gboolean _skype_connection_on_authenticate_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = skype_connection_on_authenticate_timeout ((SkypeConnection*) self);
	return result;
}


static gboolean skype_connection_authenticate_co (SkypeConnectionAuthenticateData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp1_ = 0;
	_data_->_tmp1_ = _data_->self->priv->status;
	if (_data_->_tmp1_ == SKYPE_AUTHENTICATION_STATUS_AUTHENTICATED) {
		_data_->_tmp0_ = TRUE;
	} else {
		_data_->_tmp2_ = 0;
		_data_->_tmp2_ = _data_->self->priv->status;
		_data_->_tmp0_ = _data_->_tmp2_ == SKYPE_AUTHENTICATION_STATUS_AUTHENTICATING;
	}
	if (_data_->_tmp0_) {
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp3_ = 0;
	_data_->_tmp3_ = _data_->self->priv->status;
	if (_data_->_tmp3_ == SKYPE_AUTHENTICATION_STATUS_DISCONNECTED) {
		skype_connection_connect (_data_->self);
	}
	_data_->_tmp4_ = 0;
	_data_->_tmp4_ = _data_->self->priv->status;
	_vala_assert (_data_->_tmp4_ == SKYPE_AUTHENTICATION_STATUS_CONNECTED, "this.status == AuthenticationStatus.CONNECTED");
	{
		static GQuark _tmp20_label0 = 0;
		static GQuark _tmp20_label1 = 0;
		_data_->self->priv->status = SKYPE_AUTHENTICATION_STATUS_AUTHENTICATING;
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = _data_->self->priv->proxy;
		_data_->_tmp6_ = NULL;
		_data_->_tmp6_ = _data_->self->application_name;
		_data_->_tmp7_ = NULL;
		_data_->_tmp7_ = g_strconcat ("NAME ", _data_->_tmp6_, NULL);
		_data_->_tmp8_ = NULL;
		_data_->_tmp8_ = _data_->_tmp7_;
		_data_->_state_ = 1;
		skype_api_invoke (_data_->_tmp5_, _data_->_tmp8_, skype_connection_authenticate_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp9_ = NULL;
		_data_->_tmp9_ = skype_api_invoke_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error_);
		_data_->_tmp10_ = NULL;
		_data_->_tmp10_ = _data_->_tmp9_;
		_g_free0 (_data_->_tmp8_);
		_data_->response = _data_->_tmp10_;
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			if (_data_->_inner_error_->domain == G_IO_ERROR) {
				goto __catch20_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
		_data_->_tmp11_ = NULL;
		_data_->_tmp11_ = _data_->response;
		_data_->_tmp12_ = NULL;
		_data_->_tmp13_ = NULL;
		_data_->_tmp13_ = _data_->_tmp12_ = g_strsplit (_data_->_tmp11_, " ", 0);
		_data_->_tmp14_ = NULL;
		_data_->_tmp14__length1 = 0;
		_data_->_tmp14_ = _data_->_tmp13_;
		_data_->_tmp14__length1 = _vala_array_length (_data_->_tmp12_);
		_data_->_tmp15_ = NULL;
		_data_->_tmp15_ = _data_->_tmp14_[0];
		_data_->_tmp16_ = NULL;
		_data_->_tmp16_ = g_strdup (_data_->_tmp15_);
		_data_->_tmp17_ = NULL;
		_data_->_tmp17_ = _data_->_tmp16_;
		_data_->_tmp14_ = (_vala_array_free (_data_->_tmp14_, _data_->_tmp14__length1, (GDestroyNotify) g_free), NULL);
		_data_->response_type = _data_->_tmp17_;
		_data_->_tmp18_ = NULL;
		_data_->_tmp18_ = _data_->response_type;
		_data_->_tmp19_ = NULL;
		_data_->_tmp21_ = 0U;
		_data_->_tmp19_ = _data_->_tmp18_;
		_data_->_tmp21_ = (NULL == _data_->_tmp19_) ? 0 : g_quark_from_string (_data_->_tmp19_);
		if (_data_->_tmp21_ == ((0 != _tmp20_label0) ? _tmp20_label0 : (_tmp20_label0 = g_quark_from_static_string ("OK")))) {
			switch (0) {
				default:
				{
					_data_->_tmp23_ = NULL;
					_data_->_tmp23_ = _data_->self->priv->proxy;
					_data_->_tmp24_ = 0U;
					_data_->_tmp24_ = skype_connection_PROTOCOL_VERSION;
					_data_->_tmp25_ = NULL;
					_data_->_tmp25_ = g_strdup_printf ("%u", _data_->_tmp24_);
					_data_->_tmp26_ = NULL;
					_data_->_tmp26_ = _data_->_tmp25_;
					_data_->_tmp27_ = NULL;
					_data_->_tmp27_ = g_strconcat ("PROTOCOL ", _data_->_tmp26_, NULL);
					_data_->_tmp28_ = NULL;
					_data_->_tmp28_ = _data_->_tmp27_;
					_data_->_state_ = 2;
					skype_api_invoke (_data_->_tmp23_, _data_->_tmp28_, skype_connection_authenticate_ready, _data_);
					return FALSE;
					_state_2:
					_data_->_tmp29_ = NULL;
					_data_->_tmp29_ = skype_api_invoke_finish (_data_->_tmp23_, _data_->_res_, &_data_->_inner_error_);
					_data_->_tmp30_ = NULL;
					_data_->_tmp30_ = _data_->_tmp29_;
					_g_free0 (_data_->_tmp28_);
					_g_free0 (_data_->_tmp26_);
					_data_->_tmp22_ = _data_->_tmp30_;
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
						_g_free0 (_data_->response_type);
						_g_free0 (_data_->response);
						if (_data_->_inner_error_->domain == G_IO_ERROR) {
							goto __catch20_g_io_error;
						}
						_g_free0 (_data_->response_type);
						_g_free0 (_data_->response);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
						g_clear_error (&_data_->_inner_error_);
						return FALSE;
					}
					_data_->_tmp31_ = NULL;
					_data_->_tmp31_ = _data_->_tmp22_;
					_data_->_tmp22_ = NULL;
					_g_free0 (_data_->response);
					_data_->response = _data_->_tmp31_;
					_data_->self->priv->status = SKYPE_AUTHENTICATION_STATUS_AUTHENTICATED;
					g_signal_emit_by_name (_data_->self, "authenticated");
					_g_free0 (_data_->_tmp22_);
					break;
				}
			}
		} else if (_data_->_tmp21_ == ((0 != _tmp20_label1) ? _tmp20_label1 : (_tmp20_label1 = g_quark_from_static_string ("CONNSTATUS")))) {
			switch (0) {
				default:
				{
					g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _skype_connection_on_authenticate_timeout_gsource_func, g_object_ref (_data_->self), g_object_unref);
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					_data_->self->priv->status = SKYPE_AUTHENTICATION_STATUS_CONNECTED;
					break;
				}
			}
		}
		_g_free0 (_data_->response_type);
		_g_free0 (_data_->response);
	}
	goto __finally20;
	__catch20_g_io_error:
	{
		_data_->_error_ = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp32_ = NULL;
		_data_->_tmp32_ = _data_->_error_;
		_data_->_tmp33_ = NULL;
		_data_->_tmp33_ = _data_->_tmp32_->message;
		_data_->_tmp34_ = NULL;
		_data_->_tmp34_ = g_error_new_literal (SKYPE_ERROR, SKYPE_ERROR_CONNECTION, _data_->_tmp33_);
		_data_->_inner_error_ = _data_->_tmp34_;
		_g_error_free0 (_data_->_error_);
		goto __finally20;
	}
	__finally20:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == SKYPE_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void skype_connection_assert_authenticated (SkypeConnection* self, GError** error) {
	SkypeAuthenticationStatus _tmp0_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->status;
	if (_tmp0_ != SKYPE_AUTHENTICATION_STATUS_AUTHENTICATED) {
		GError* _tmp1_ = NULL;
		_tmp1_ = g_error_new_literal (SKYPE_ERROR, SKYPE_ERROR_AUTHENTICATION, "Skype is not authenticated");
		_inner_error_ = _tmp1_;
		if (_inner_error_->domain == SKYPE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void skype_connection_set_status_data_free (gpointer _data) {
	SkypeConnectionSetStatusData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SkypeConnectionSetStatusData, _data_);
}


void skype_connection_set_status (SkypeConnection* self, SkypePresenceStatus status, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	SkypeConnectionSetStatusData* _data_;
	SkypeConnection* _tmp0_ = NULL;
	SkypePresenceStatus _tmp1_ = 0;
	_data_ = g_slice_new0 (SkypeConnectionSetStatusData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, skype_connection_set_status);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, skype_connection_set_status_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = status;
	_data_->status = _tmp1_;
	skype_connection_set_status_co (_data_);
}


void skype_connection_set_status_finish (SkypeConnection* self, GAsyncResult* _res_, GError** error) {
	SkypeConnectionSetStatusData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void skype_connection_set_status_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	SkypeConnectionSetStatusData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	skype_connection_set_status_co (_data_);
}


static gboolean skype_connection_set_status_co (SkypeConnectionSetStatusData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	skype_connection_assert_authenticated (_data_->self, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == SKYPE_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	{
		_data_->_tmp0_ = 0;
		_data_->_tmp0_ = _data_->status;
		_data_->_tmp1_ = NULL;
		_data_->_tmp1_ = skype_presence_status_to_string (_data_->_tmp0_);
		_data_->status_string = _data_->_tmp1_;
		_data_->_tmp2_ = NULL;
		_data_->_tmp2_ = _data_->self->priv->proxy;
		_data_->_tmp3_ = NULL;
		_data_->_tmp3_ = _data_->status_string;
		_data_->_tmp4_ = NULL;
		_data_->_tmp4_ = g_strconcat ("SET USERSTATUS ", _data_->_tmp3_, NULL);
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = _data_->_tmp4_;
		_data_->_state_ = 1;
		skype_api_invoke (_data_->_tmp2_, _data_->_tmp5_, skype_connection_set_status_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp6_ = NULL;
		_data_->_tmp6_ = skype_api_invoke_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error_);
		_data_->_tmp7_ = NULL;
		_data_->_tmp7_ = _data_->_tmp6_;
		_g_free0 (_data_->_tmp7_);
		_g_free0 (_data_->_tmp5_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			_g_free0 (_data_->status_string);
			if (_data_->_inner_error_->domain == G_IO_ERROR) {
				goto __catch21_g_io_error;
			}
			_g_free0 (_data_->status_string);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
		_g_free0 (_data_->status_string);
	}
	goto __finally21;
	__catch21_g_io_error:
	{
		_data_->_error_ = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp8_ = NULL;
		_data_->_tmp8_ = _data_->_error_;
		_data_->_tmp9_ = NULL;
		_data_->_tmp9_ = _data_->_tmp8_->message;
		_data_->_tmp10_ = NULL;
		_data_->_tmp10_ = g_error_new_literal (SKYPE_ERROR, SKYPE_ERROR_CONNECTION, _data_->_tmp9_);
		_data_->_inner_error_ = _data_->_tmp10_;
		_g_error_free0 (_data_->_error_);
		goto __finally21;
	}
	__finally21:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == SKYPE_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void skype_connection_set_auto_away_data_free (gpointer _data) {
	SkypeConnectionSetAutoAwayData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SkypeConnectionSetAutoAwayData, _data_);
}


void skype_connection_set_auto_away (SkypeConnection* self, gboolean enabled, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	SkypeConnectionSetAutoAwayData* _data_;
	SkypeConnection* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	_data_ = g_slice_new0 (SkypeConnectionSetAutoAwayData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, skype_connection_set_auto_away);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, skype_connection_set_auto_away_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = enabled;
	_data_->enabled = _tmp1_;
	skype_connection_set_auto_away_co (_data_);
}


void skype_connection_set_auto_away_finish (SkypeConnection* self, GAsyncResult* _res_, GError** error) {
	SkypeConnectionSetAutoAwayData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void skype_connection_set_auto_away_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	SkypeConnectionSetAutoAwayData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	skype_connection_set_auto_away_co (_data_);
}


static gboolean skype_connection_set_auto_away_co (SkypeConnectionSetAutoAwayData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	skype_connection_assert_authenticated (_data_->self, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == SKYPE_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	{
		_data_->_tmp1_ = FALSE;
		_data_->_tmp1_ = _data_->enabled;
		if (_data_->_tmp1_) {
			_data_->_tmp0_ = "ON";
		} else {
			_data_->_tmp0_ = "OFF";
		}
		_data_->_tmp2_ = NULL;
		_data_->_tmp2_ = g_strdup (_data_->_tmp0_);
		_data_->enabled_string = _data_->_tmp2_;
		_data_->_tmp3_ = NULL;
		_data_->_tmp3_ = _data_->self->priv->proxy;
		_data_->_tmp4_ = NULL;
		_data_->_tmp4_ = _data_->enabled_string;
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = g_strconcat ("SET AUTOAWAY ", _data_->_tmp4_, NULL);
		_data_->_tmp6_ = NULL;
		_data_->_tmp6_ = _data_->_tmp5_;
		_data_->_state_ = 1;
		skype_api_invoke (_data_->_tmp3_, _data_->_tmp6_, skype_connection_set_auto_away_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp7_ = NULL;
		_data_->_tmp7_ = skype_api_invoke_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error_);
		_data_->_tmp8_ = NULL;
		_data_->_tmp8_ = _data_->_tmp7_;
		_g_free0 (_data_->_tmp8_);
		_g_free0 (_data_->_tmp6_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			_g_free0 (_data_->enabled_string);
			if (_data_->_inner_error_->domain == G_IO_ERROR) {
				goto __catch22_g_io_error;
			}
			_g_free0 (_data_->enabled_string);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
		_g_free0 (_data_->enabled_string);
	}
	goto __finally22;
	__catch22_g_io_error:
	{
		_data_->_error_ = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp9_ = NULL;
		_data_->_tmp9_ = _data_->_error_;
		_data_->_tmp10_ = NULL;
		_data_->_tmp10_ = _data_->_tmp9_->message;
		_data_->_tmp11_ = NULL;
		_data_->_tmp11_ = g_error_new_literal (SKYPE_ERROR, SKYPE_ERROR_CONNECTION, _data_->_tmp10_);
		_data_->_inner_error_ = _data_->_tmp11_;
		_g_error_free0 (_data_->_error_);
		goto __finally22;
	}
	__finally22:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == SKYPE_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void skype_connection_reset_idle_timer_data_free (gpointer _data) {
	SkypeConnectionResetIdleTimerData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SkypeConnectionResetIdleTimerData, _data_);
}


void skype_connection_reset_idle_timer (SkypeConnection* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	SkypeConnectionResetIdleTimerData* _data_;
	SkypeConnection* _tmp0_ = NULL;
	_data_ = g_slice_new0 (SkypeConnectionResetIdleTimerData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, skype_connection_reset_idle_timer);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, skype_connection_reset_idle_timer_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	skype_connection_reset_idle_timer_co (_data_);
}


void skype_connection_reset_idle_timer_finish (SkypeConnection* self, GAsyncResult* _res_, GError** error) {
	SkypeConnectionResetIdleTimerData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void skype_connection_reset_idle_timer_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	SkypeConnectionResetIdleTimerData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	skype_connection_reset_idle_timer_co (_data_);
}


static gboolean skype_connection_reset_idle_timer_co (SkypeConnectionResetIdleTimerData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	skype_connection_assert_authenticated (_data_->self, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == SKYPE_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	{
		_data_->_tmp0_ = NULL;
		_data_->_tmp0_ = _data_->self->priv->proxy;
		_data_->_state_ = 1;
		skype_api_invoke (_data_->_tmp0_, "RESETIDLETIMER", skype_connection_reset_idle_timer_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp1_ = NULL;
		_data_->_tmp1_ = skype_api_invoke_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error_);
		_data_->_tmp2_ = NULL;
		_data_->_tmp2_ = _data_->_tmp1_;
		_g_free0 (_data_->_tmp2_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			if (_data_->_inner_error_->domain == G_IO_ERROR) {
				goto __catch23_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	goto __finally23;
	__catch23_g_io_error:
	{
		_data_->_error_ = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp3_ = NULL;
		_data_->_tmp3_ = _data_->_error_;
		_data_->_tmp4_ = NULL;
		_data_->_tmp4_ = _data_->_tmp3_->message;
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = g_error_new_literal (SKYPE_ERROR, SKYPE_ERROR_CONNECTION, _data_->_tmp4_);
		_data_->_inner_error_ = _data_->_tmp5_;
		_g_error_free0 (_data_->_error_);
		goto __finally23;
	}
	__finally23:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == SKYPE_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void skype_connection_real_connected (SkypeConnection* self) {
	SkypeAuthenticationStatus _tmp0_ = 0;
	GError * _inner_error_ = NULL;
	_tmp0_ = self->priv->status;
	if (_tmp0_ == SKYPE_AUTHENTICATION_STATUS_CONNECTED) {
		{
			skype_connection_authenticate (self, NULL, NULL);
		}
		goto __finally24;
		__catch24_g_io_error:
		{
			GError* _error_ = NULL;
			GError* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_tmp1_ = _error_;
			_tmp2_ = _tmp1_->message;
			g_warning ("skype.vala:318: %s", _tmp2_);
			_g_error_free0 (_error_);
		}
		__finally24:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void skype_connection_real_disconnected (SkypeConnection* self) {
}


static void skype_connection_real_authenticated (SkypeConnection* self) {
}


static void skype_connection_class_init (SkypeConnectionClass * klass) {
	skype_connection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SkypeConnectionPrivate));
	((SkypeConnectionClass *) klass)->connected = skype_connection_real_connected;
	((SkypeConnectionClass *) klass)->disconnected = skype_connection_real_disconnected;
	((SkypeConnectionClass *) klass)->authenticated = skype_connection_real_authenticated;
	G_OBJECT_CLASS (klass)->finalize = skype_connection_finalize;
	g_signal_new ("connected", SKYPE_TYPE_CONNECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SkypeConnectionClass, connected), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("disconnected", SKYPE_TYPE_CONNECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SkypeConnectionClass, disconnected), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("authenticated", SKYPE_TYPE_CONNECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SkypeConnectionClass, authenticated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void skype_connection_instance_init (SkypeConnection * self) {
	self->priv = SKYPE_CONNECTION_GET_PRIVATE (self);
	self->priv->name_watcher_id = (guint) 0;
}


static void skype_connection_finalize (GObject* obj) {
	SkypeConnection * self;
	guint _tmp0_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SKYPE_TYPE_CONNECTION, SkypeConnection);
	_tmp0_ = self->priv->name_watcher_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->name_watcher_id;
		g_bus_unwatch_name (_tmp1_);
	}
	_g_free0 (self->application_name);
	_g_object_unref0 (self->priv->proxy);
	G_OBJECT_CLASS (skype_connection_parent_class)->finalize (obj);
}


GType skype_connection_get_type (void) {
	static volatile gsize skype_connection_type_id__volatile = 0;
	if (g_once_init_enter (&skype_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SkypeConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skype_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkypeConnection), 0, (GInstanceInitFunc) skype_connection_instance_init, NULL };
		GType skype_connection_type_id;
		skype_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "SkypeConnection", &g_define_type_info, 0);
		g_once_init_leave (&skype_connection_type_id__volatile, skype_connection_type_id);
	}
	return skype_connection_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



