/* timer.c generated by valac 0.26.1, the Vala compiler
 * generated from timer.vala, do not modify */

/*
 * Copyright (c) 2011-2013 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Arun Mahapatra <pratikarun@gmail.com>
 *          Kamil Prusko <kamilprusko@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <libgnome-desktop/gnome-bg-crossfade.h>
#include <libgnome-desktop/gnome-bg-slide-show.h>
#include <libgnome-desktop/gnome-bg.h>
#include <libgnome-desktop/gnome-desktop-thumbnail.h>
#include <libgnome-desktop/gnome-idle-monitor.h>
#include <libgnome-desktop/gnome-languages.h>
#include <libgnome-desktop/gnome-pnp-ids.h>
#include <libgnome-desktop/gnome-rr-config.h>
#include <libgnome-desktop/gnome-rr.h>
#include <libgnome-desktop/gnome-wall-clock.h>
#include <libgnome-desktop/gnome-xkb-info.h>
#include <gio/gio.h>


#define POMODORO_TYPE_STATE (pomodoro_state_get_type ())

#define POMODORO_TYPE_TIMER (pomodoro_timer_get_type ())
#define POMODORO_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_TIMER, PomodoroTimer))
#define POMODORO_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_TIMER, PomodoroTimerClass))
#define POMODORO_IS_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_TIMER))
#define POMODORO_IS_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_TIMER))
#define POMODORO_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_TIMER, PomodoroTimerClass))

typedef struct _PomodoroTimer PomodoroTimer;
typedef struct _PomodoroTimerClass PomodoroTimerClass;
typedef struct _PomodoroTimerPrivate PomodoroTimerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	POMODORO_STATE_NULL = 0,
	POMODORO_STATE_POMODORO = 1,
	POMODORO_STATE_PAUSE = 2,
	POMODORO_STATE_IDLE = 3
} PomodoroState;

struct _PomodoroTimer {
	GObject parent_instance;
	PomodoroTimerPrivate * priv;
};

struct _PomodoroTimerClass {
	GObjectClass parent_class;
	void (*destroy) (PomodoroTimer* self);
};

struct _PomodoroTimerPrivate {
	guint timeout_source;
	GnomeIdleMonitor* idle_monitor;
	guint became_active_id;
	GSettings* settings;
	GSettings* settings_state;
	gdouble current_timestamp;
	gdouble pomodoro_end_timestamp;
	gboolean is_long_break;
	PomodoroState _state;
	gdouble _elapsed;
	gdouble _state_duration;
	gdouble _state_timestamp;
	gdouble _session;
	gdouble _session_limit;
};

typedef enum  {
	POMODORO_DATE_TIME_ERROR_PARSE
} PomodoroDateTimeError;
#define POMODORO_DATE_TIME_ERROR pomodoro_date_time_error_quark ()

static gpointer pomodoro_timer_parent_class = NULL;

#define POMODORO_POMODORO_ACCEPTANCE 0.05
#define POMODORO_LONG_BREAK_ACCEPTANCE 0.90
#define POMODORO_SHORT_LONG_PAUSE_ACCEPTANCE 0.5
GType pomodoro_state_get_type (void) G_GNUC_CONST;
gchar* pomodoro_state_to_string (PomodoroState state);
PomodoroState pomodoro_string_to_state (const gchar* state);
GType pomodoro_timer_get_type (void) G_GNUC_CONST;
#define POMODORO_TIMER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_TIMER, PomodoroTimerPrivate))
enum  {
	POMODORO_TIMER_DUMMY_PROPERTY,
	POMODORO_TIMER_ELAPSED,
	POMODORO_TIMER_STATE,
	POMODORO_TIMER_STATE_DURATION,
	POMODORO_TIMER_STATE_TIMESTAMP,
	POMODORO_TIMER_SESSION,
	POMODORO_TIMER_SESSION_LIMIT
};
PomodoroTimer* pomodoro_timer_new (void);
PomodoroTimer* pomodoro_timer_construct (GType object_type);
void pomodoro_timer_set_session (PomodoroTimer* self, gdouble value);
void pomodoro_timer_set_session_limit (PomodoroTimer* self, gdouble value);
void pomodoro_timer_set_state_duration (PomodoroTimer* self, gdouble value);
void pomodoro_timer_set_state_timestamp (PomodoroTimer* self, gdouble value);
GSettings* pomodoro_get_settings (void);
static void pomodoro_timer_on_settings_changed (PomodoroTimer* self, GSettings* settings, const gchar* key);
static void _pomodoro_timer_on_settings_changed_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
static gboolean pomodoro_timer_do_set_state_full (PomodoroTimer* self, PomodoroState state, gdouble duration, gdouble timestamp);
gdouble pomodoro_get_real_time (void);
gdouble pomodoro_timer_get_elapsed (PomodoroTimer* self);
gdouble pomodoro_timer_get_state_duration (PomodoroTimer* self);
PomodoroState pomodoro_timer_get_state (PomodoroTimer* self);
gdouble pomodoro_timer_get_state_timestamp (PomodoroTimer* self);
void pomodoro_timer_disable_idle_monitor (PomodoroTimer* self);
gdouble pomodoro_timer_get_session (PomodoroTimer* self);
void pomodoro_timer_enable_idle_monitor (PomodoroTimer* self);
gdouble pomodoro_timer_get_session_limit (PomodoroTimer* self);
static gboolean pomodoro_timer_on_timeout (PomodoroTimer* self);
static gboolean _pomodoro_timer_on_timeout_gsource_func (gpointer self);
void pomodoro_timer_set_elapsed (PomodoroTimer* self, gdouble value);
void pomodoro_timer_set_state_full (PomodoroTimer* self, PomodoroState state, gdouble duration, gdouble timestamp);
gchar* pomodoro_datetime_to_string (GDateTime* datetime);
void pomodoro_timer_update (PomodoroTimer* self);
void pomodoro_timer_restore (PomodoroTimer* self);
GQuark pomodoro_date_time_error_quark (void);
GDateTime* pomodoro_datetime_from_string (const gchar* date_string, GError** error);
void pomodoro_timer_start (PomodoroTimer* self);
void pomodoro_timer_set_state (PomodoroTimer* self, PomodoroState value);
void pomodoro_timer_stop (PomodoroTimer* self);
void pomodoro_timer_reset (PomodoroTimer* self);
static void pomodoro_timer_on_idle_monitor_became_active (PomodoroTimer* self, GnomeIdleMonitor* monitor);
static void _pomodoro_timer_on_idle_monitor_became_active_gnome_idle_monitor_watch_func (GnomeIdleMonitor* monitor, guint id, gpointer self);
static void pomodoro_timer_real_dispose (GObject* base);
static void pomodoro_timer_real_destroy (PomodoroTimer* self);
static void pomodoro_timer_finalize (GObject* obj);
static void _vala_pomodoro_timer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_pomodoro_timer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType pomodoro_state_get_type (void) {
	static volatile gsize pomodoro_state_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_state_type_id__volatile)) {
		static const GEnumValue values[] = {{POMODORO_STATE_NULL, "POMODORO_STATE_NULL", "null"}, {POMODORO_STATE_POMODORO, "POMODORO_STATE_POMODORO", "pomodoro"}, {POMODORO_STATE_PAUSE, "POMODORO_STATE_PAUSE", "pause"}, {POMODORO_STATE_IDLE, "POMODORO_STATE_IDLE", "idle"}, {0, NULL, NULL}};
		GType pomodoro_state_type_id;
		pomodoro_state_type_id = g_enum_register_static ("PomodoroState", values);
		g_once_init_leave (&pomodoro_state_type_id__volatile, pomodoro_state_type_id);
	}
	return pomodoro_state_type_id__volatile;
}


gchar* pomodoro_state_to_string (PomodoroState state) {
	gchar* result = NULL;
	PomodoroState _tmp0_ = 0;
	gchar* _tmp5_ = NULL;
	_tmp0_ = state;
	switch (_tmp0_) {
		case POMODORO_STATE_NULL:
		{
			gchar* _tmp1_ = NULL;
			_tmp1_ = g_strdup ("null");
			result = _tmp1_;
			return result;
		}
		case POMODORO_STATE_POMODORO:
		{
			gchar* _tmp2_ = NULL;
			_tmp2_ = g_strdup ("pomodoro");
			result = _tmp2_;
			return result;
		}
		case POMODORO_STATE_PAUSE:
		{
			gchar* _tmp3_ = NULL;
			_tmp3_ = g_strdup ("pause");
			result = _tmp3_;
			return result;
		}
		case POMODORO_STATE_IDLE:
		{
			gchar* _tmp4_ = NULL;
			_tmp4_ = g_strdup ("idle");
			result = _tmp4_;
			return result;
		}
		default:
		break;
	}
	_tmp5_ = g_strdup ("");
	result = _tmp5_;
	return result;
}


PomodoroState pomodoro_string_to_state (const gchar* state) {
	PomodoroState result = 0;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	g_return_val_if_fail (state != NULL, 0);
	_tmp0_ = state;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("null")))) {
		switch (0) {
			default:
			{
				result = POMODORO_STATE_NULL;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("pomodoro")))) {
		switch (0) {
			default:
			{
				result = POMODORO_STATE_POMODORO;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("pause")))) {
		switch (0) {
			default:
			{
				result = POMODORO_STATE_PAUSE;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("idle")))) {
		switch (0) {
			default:
			{
				result = POMODORO_STATE_IDLE;
				return result;
			}
		}
	}
	result = POMODORO_STATE_NULL;
	return result;
}


static void _pomodoro_timer_on_settings_changed_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	pomodoro_timer_on_settings_changed ((PomodoroTimer*) self, _sender, key);
}


PomodoroTimer* pomodoro_timer_construct (GType object_type) {
	PomodoroTimer * self = NULL;
	GnomeIdleMonitor* _tmp0_ = NULL;
	GSettings* settings = NULL;
	GSettings* _tmp1_ = NULL;
	GSettings* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	GSettings* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	self = (PomodoroTimer*) g_object_new (object_type, NULL);
	self->priv->_state = POMODORO_STATE_NULL;
	self->priv->_elapsed = 0.0;
	self->priv->current_timestamp = 0.0;
	pomodoro_timer_set_session (self, 0.0);
	pomodoro_timer_set_session_limit (self, 0.0);
	pomodoro_timer_set_state_duration (self, 0.0);
	pomodoro_timer_set_state_timestamp (self, 0.0);
	self->priv->is_long_break = FALSE;
	self->priv->timeout_source = (guint) 0;
	_tmp0_ = gnome_idle_monitor_new ();
	_g_object_unref0 (self->priv->idle_monitor);
	self->priv->idle_monitor = _tmp0_;
	self->priv->became_active_id = (guint) 0;
	_tmp1_ = pomodoro_get_settings ();
	settings = _tmp1_;
	_tmp2_ = g_settings_get_child (settings, "preferences");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp2_;
	_tmp3_ = self->priv->settings;
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _pomodoro_timer_on_settings_changed_g_settings_changed, self, 0);
	_tmp4_ = g_settings_get_child (settings, "state");
	_g_object_unref0 (self->priv->settings_state);
	self->priv->settings_state = _tmp4_;
	_tmp5_ = self->priv->settings;
	_tmp6_ = g_settings_get_double (_tmp5_, "long-break-interval");
	pomodoro_timer_set_session_limit (self, _tmp6_);
	_g_object_unref0 (settings);
	return self;
}


PomodoroTimer* pomodoro_timer_new (void) {
	return pomodoro_timer_construct (POMODORO_TYPE_TIMER);
}


static gboolean _pomodoro_timer_on_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = pomodoro_timer_on_timeout ((PomodoroTimer*) self);
	return result;
}


static gboolean pomodoro_timer_do_set_state_full (PomodoroTimer* self, PomodoroState state, gdouble duration, gdouble timestamp) {
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gdouble elapsed = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gboolean wrap_elapsed = FALSE;
	gboolean is_long_break = FALSE;
	gboolean _tmp3_ = FALSE;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gboolean is_requested = FALSE;
	gdouble pomodoro_duration = 0.0;
	GSettings* _tmp9_ = NULL;
	gdouble _tmp10_ = 0.0;
	gdouble short_break_duration = 0.0;
	GSettings* _tmp11_ = NULL;
	gdouble _tmp12_ = 0.0;
	gdouble long_break_duration = 0.0;
	GSettings* _tmp13_ = NULL;
	gdouble _tmp14_ = 0.0;
	gdouble long_pause_acceptance_time = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	PomodoroState _tmp20_ = 0;
	PomodoroState _tmp21_ = 0;
	PomodoroState _tmp22_ = 0;
	gboolean _tmp70_ = FALSE;
	guint _tmp71_ = 0U;
	gboolean _tmp74_ = FALSE;
	PomodoroState _tmp75_ = 0;
	PomodoroState _tmp77_ = 0;
	gdouble _tmp78_ = 0.0;
	gdouble _tmp79_ = 0.0;
	gboolean _tmp80_ = FALSE;
	gboolean _tmp81_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = pomodoro_get_real_time ();
	self->priv->current_timestamp = _tmp0_;
	_tmp1_ = pomodoro_timer_get_elapsed (self);
	_tmp2_ = _tmp1_;
	elapsed = _tmp2_;
	wrap_elapsed = FALSE;
	is_long_break = FALSE;
	_tmp4_ = pomodoro_timer_get_elapsed (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->_state_duration;
	if (_tmp5_ < _tmp6_) {
		_tmp3_ = TRUE;
	} else {
		PomodoroState _tmp7_ = 0;
		PomodoroState _tmp8_ = 0;
		_tmp7_ = pomodoro_timer_get_state (self);
		_tmp8_ = _tmp7_;
		_tmp3_ = _tmp8_ == POMODORO_STATE_IDLE;
	}
	is_requested = _tmp3_;
	_tmp9_ = self->priv->settings;
	_tmp10_ = g_settings_get_double (_tmp9_, "pomodoro-duration");
	pomodoro_duration = _tmp10_;
	_tmp11_ = self->priv->settings;
	_tmp12_ = g_settings_get_double (_tmp11_, "short-break-duration");
	short_break_duration = _tmp12_;
	_tmp13_ = self->priv->settings;
	_tmp14_ = g_settings_get_double (_tmp13_, "long-break-duration");
	long_break_duration = _tmp14_;
	_tmp15_ = short_break_duration;
	_tmp16_ = long_break_duration;
	long_pause_acceptance_time = (_tmp15_ * (1.0 - POMODORO_SHORT_LONG_PAUSE_ACCEPTANCE)) + (_tmp16_ * POMODORO_SHORT_LONG_PAUSE_ACCEPTANCE);
	_tmp17_ = timestamp;
	_tmp18_ = self->priv->current_timestamp;
	if (_tmp17_ > _tmp18_) {
		gdouble _tmp19_ = 0.0;
		_tmp19_ = self->priv->current_timestamp;
		timestamp = _tmp19_;
	}
	_tmp20_ = state;
	_tmp21_ = pomodoro_timer_get_state (self);
	_tmp22_ = _tmp21_;
	if (_tmp20_ == _tmp22_) {
		gdouble _tmp23_ = 0.0;
		gdouble _tmp25_ = 0.0;
		_tmp23_ = duration;
		if (_tmp23_ == ((gdouble) 0)) {
			gdouble _tmp24_ = 0.0;
			_tmp24_ = self->priv->_state_duration;
			duration = _tmp24_;
		}
		_tmp25_ = timestamp;
		if (_tmp25_ == ((gdouble) 0)) {
			gdouble _tmp26_ = 0.0;
			_tmp26_ = self->priv->_state_timestamp;
			timestamp = _tmp26_;
		}
		wrap_elapsed = TRUE;
	} else {
		gboolean _tmp27_ = FALSE;
		guint _tmp28_ = 0U;
		PomodoroState _tmp31_ = 0;
		gdouble _tmp32_ = 0.0;
		gboolean _tmp34_ = FALSE;
		PomodoroState _tmp35_ = 0;
		PomodoroState _tmp36_ = 0;
		PomodoroState _tmp46_ = 0;
		_tmp28_ = self->priv->timeout_source;
		if (_tmp28_ != ((guint) 0)) {
			gboolean _tmp29_ = FALSE;
			_tmp29_ = is_requested;
			_tmp27_ = _tmp29_;
		} else {
			_tmp27_ = FALSE;
		}
		if (_tmp27_) {
			guint _tmp30_ = 0U;
			_tmp30_ = self->priv->timeout_source;
			g_source_remove (_tmp30_);
			self->priv->timeout_source = (guint) 0;
		}
		_tmp31_ = state;
		if (_tmp31_ != POMODORO_STATE_IDLE) {
			pomodoro_timer_disable_idle_monitor (self);
		}
		_tmp32_ = timestamp;
		if (_tmp32_ == ((gdouble) 0)) {
			gdouble _tmp33_ = 0.0;
			_tmp33_ = self->priv->current_timestamp;
			timestamp = _tmp33_;
		}
		_tmp35_ = pomodoro_timer_get_state (self);
		_tmp36_ = _tmp35_;
		if (_tmp36_ == POMODORO_STATE_POMODORO) {
			gdouble _tmp37_ = 0.0;
			gdouble _tmp38_ = 0.0;
			gdouble _tmp39_ = 0.0;
			_tmp37_ = pomodoro_timer_get_elapsed (self);
			_tmp38_ = _tmp37_;
			_tmp39_ = self->priv->_state_duration;
			_tmp34_ = _tmp38_ >= (_tmp39_ * POMODORO_POMODORO_ACCEPTANCE);
		} else {
			_tmp34_ = FALSE;
		}
		if (_tmp34_) {
			gdouble _tmp40_ = 0.0;
			gdouble _tmp41_ = 0.0;
			gdouble _tmp42_ = 0.0;
			gdouble _tmp43_ = 0.0;
			gdouble _tmp44_ = 0.0;
			gdouble _tmp45_ = 0.0;
			_tmp40_ = self->priv->_session;
			_tmp41_ = pomodoro_timer_get_elapsed (self);
			_tmp42_ = _tmp41_;
			_tmp43_ = self->priv->_state_duration;
			_tmp44_ = MIN (_tmp42_ / _tmp43_, 1.0);
			pomodoro_timer_set_session (self, _tmp40_ + _tmp44_);
			_tmp45_ = timestamp;
			self->priv->pomodoro_end_timestamp = _tmp45_;
		}
		_tmp46_ = state;
		switch (_tmp46_) {
			case POMODORO_STATE_IDLE:
			{
				pomodoro_timer_enable_idle_monitor (self);
				break;
			}
			case POMODORO_STATE_POMODORO:
			{
				gdouble _tmp47_ = 0.0;
				gdouble break_time = 0.0;
				gdouble _tmp49_ = 0.0;
				gdouble _tmp50_ = 0.0;
				gdouble _tmp51_ = 0.0;
				gdouble _tmp52_ = 0.0;
				_tmp47_ = duration;
				if (_tmp47_ == ((gdouble) 0)) {
					gdouble _tmp48_ = 0.0;
					_tmp48_ = pomodoro_duration;
					duration = _tmp48_;
				}
				_tmp49_ = timestamp;
				_tmp50_ = self->priv->pomodoro_end_timestamp;
				break_time = _tmp49_ - _tmp50_;
				_tmp51_ = break_time;
				_tmp52_ = long_pause_acceptance_time;
				if (_tmp51_ >= _tmp52_) {
					pomodoro_timer_set_session (self, 0.0);
				}
				break;
			}
			case POMODORO_STATE_PAUSE:
			{
				gdouble _tmp53_ = 0.0;
				gdouble _tmp54_ = 0.0;
				gboolean _tmp55_ = FALSE;
				PomodoroState _tmp56_ = 0;
				PomodoroState _tmp57_ = 0;
				gdouble _tmp63_ = 0.0;
				_tmp53_ = self->priv->_session;
				_tmp54_ = self->priv->_session_limit;
				is_long_break = _tmp53_ >= (_tmp54_ * POMODORO_LONG_BREAK_ACCEPTANCE);
				_tmp56_ = pomodoro_timer_get_state (self);
				_tmp57_ = _tmp56_;
				if (_tmp57_ == POMODORO_STATE_POMODORO) {
					gdouble _tmp58_ = 0.0;
					gdouble _tmp59_ = 0.0;
					gdouble _tmp60_ = 0.0;
					_tmp58_ = pomodoro_timer_get_elapsed (self);
					_tmp59_ = _tmp58_;
					_tmp60_ = self->priv->_state_duration;
					_tmp55_ = _tmp59_ > _tmp60_;
				} else {
					_tmp55_ = FALSE;
				}
				if (_tmp55_) {
					gdouble _tmp61_ = 0.0;
					gdouble _tmp62_ = 0.0;
					_tmp61_ = elapsed;
					_tmp62_ = self->priv->_state_duration;
					elapsed = _tmp61_ - _tmp62_;
					wrap_elapsed = TRUE;
				}
				_tmp63_ = duration;
				if (_tmp63_ == 0.0) {
					gdouble _tmp64_ = 0.0;
					gboolean _tmp65_ = FALSE;
					_tmp65_ = is_long_break;
					if (_tmp65_) {
						gdouble _tmp66_ = 0.0;
						_tmp66_ = long_break_duration;
						_tmp64_ = _tmp66_;
					} else {
						gdouble _tmp67_ = 0.0;
						_tmp67_ = short_break_duration;
						_tmp64_ = _tmp67_;
					}
					duration = _tmp64_;
				}
				break;
			}
			case POMODORO_STATE_NULL:
			{
				guint _tmp68_ = 0U;
				_tmp68_ = self->priv->timeout_source;
				if (_tmp68_ != ((guint) 0)) {
					guint _tmp69_ = 0U;
					_tmp69_ = self->priv->timeout_source;
					g_source_remove (_tmp69_);
					self->priv->timeout_source = (guint) 0;
				}
				break;
			}
			default:
			break;
		}
	}
	_tmp71_ = self->priv->timeout_source;
	if (_tmp71_ == ((guint) 0)) {
		PomodoroState _tmp72_ = 0;
		_tmp72_ = state;
		_tmp70_ = _tmp72_ != POMODORO_STATE_NULL;
	} else {
		_tmp70_ = FALSE;
	}
	if (_tmp70_) {
		guint _tmp73_ = 0U;
		_tmp73_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, _pomodoro_timer_on_timeout_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->timeout_source = _tmp73_;
	}
	_tmp75_ = state;
	if (_tmp75_ == POMODORO_STATE_NULL) {
		_tmp74_ = TRUE;
	} else {
		PomodoroState _tmp76_ = 0;
		_tmp76_ = state;
		_tmp74_ = _tmp76_ == POMODORO_STATE_IDLE;
	}
	if (_tmp74_) {
		duration = 0.0;
		wrap_elapsed = FALSE;
	}
	g_object_freeze_notify ((GObject*) self);
	_tmp77_ = state;
	self->priv->_state = _tmp77_;
	self->priv->_elapsed = 0.0;
	_tmp78_ = timestamp;
	pomodoro_timer_set_state_timestamp (self, _tmp78_);
	_tmp79_ = duration;
	pomodoro_timer_set_state_duration (self, _tmp79_);
	_tmp80_ = is_long_break;
	self->priv->is_long_break = _tmp80_;
	_tmp81_ = wrap_elapsed;
	if (_tmp81_) {
		gdouble _tmp82_ = 0.0;
		_tmp82_ = elapsed;
		pomodoro_timer_set_elapsed (self, _tmp82_);
	}
	g_object_notify ((GObject*) self, "state");
	g_object_thaw_notify ((GObject*) self);
	result = TRUE;
	return result;
}


void pomodoro_timer_set_state_full (PomodoroTimer* self, PomodoroState state, gdouble duration, gdouble timestamp) {
	PomodoroState state_tmp = 0;
	PomodoroState _tmp0_ = 0;
	gdouble state_duration_tmp = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble elapsed_tmp = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble session_tmp = 0.0;
	gdouble _tmp4_ = 0.0;
	gboolean changed = FALSE;
	PomodoroState _tmp5_ = 0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_state;
	state_tmp = _tmp0_;
	_tmp1_ = self->priv->_state_duration;
	state_duration_tmp = _tmp1_;
	_tmp2_ = pomodoro_timer_get_elapsed (self);
	_tmp3_ = _tmp2_;
	elapsed_tmp = _tmp3_;
	_tmp4_ = self->priv->_session;
	session_tmp = _tmp4_;
	_tmp5_ = state;
	_tmp6_ = duration;
	_tmp7_ = timestamp;
	_tmp8_ = pomodoro_timer_do_set_state_full (self, _tmp5_, _tmp6_, _tmp7_);
	changed = _tmp8_;
	_tmp9_ = changed;
	if (_tmp9_) {
		GDateTime* state_date = NULL;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		GDateTime* _tmp12_ = NULL;
		GDateTime* pomodoro_end_date = NULL;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		GDateTime* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
		PomodoroState _tmp17_ = 0;
		gboolean notify_start = FALSE;
		gboolean is_requested = FALSE;
		gdouble _tmp22_ = 0.0;
		gdouble _tmp23_ = 0.0;
		gboolean is_completed = FALSE;
		gboolean _tmp24_ = FALSE;
		gchar* _tmp25_ = NULL;
		gdouble _tmp26_ = 0.0;
		gchar* pomodoro_end_date_string = NULL;
		gchar* _tmp30_ = NULL;
		gchar* state_date_string = NULL;
		GDateTime* _tmp31_ = NULL;
		gchar* _tmp32_ = NULL;
		GSettings* _tmp33_ = NULL;
		gdouble _tmp34_ = 0.0;
		GSettings* _tmp35_ = NULL;
		PomodoroState _tmp36_ = 0;
		PomodoroState _tmp37_ = 0;
		gchar* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		GSettings* _tmp40_ = NULL;
		const gchar* _tmp41_ = NULL;
		GSettings* _tmp42_ = NULL;
		gdouble _tmp43_ = 0.0;
		GSettings* _tmp44_ = NULL;
		const gchar* _tmp45_ = NULL;
		PomodoroState _tmp46_ = 0;
		gboolean _tmp48_ = FALSE;
		PomodoroState _tmp49_ = 0;
		PomodoroState _tmp52_ = 0;
		gboolean _tmp54_ = FALSE;
		PomodoroState _tmp55_ = 0;
		_tmp10_ = self->priv->_state_timestamp;
		_tmp11_ = floor (_tmp10_);
		_tmp12_ = g_date_time_new_from_unix_utc ((gint64) _tmp11_);
		state_date = _tmp12_;
		_tmp13_ = self->priv->pomodoro_end_timestamp;
		_tmp14_ = floor (_tmp13_);
		_tmp15_ = g_date_time_new_from_unix_utc ((gint64) _tmp14_);
		pomodoro_end_date = _tmp15_;
		_tmp17_ = self->priv->_state;
		if (_tmp17_ == POMODORO_STATE_POMODORO) {
			_tmp16_ = TRUE;
		} else {
			gboolean _tmp18_ = FALSE;
			PomodoroState _tmp19_ = 0;
			_tmp19_ = self->priv->_state;
			if (_tmp19_ == POMODORO_STATE_IDLE) {
				GSettings* _tmp20_ = NULL;
				gboolean _tmp21_ = FALSE;
				_tmp20_ = self->priv->settings;
				_tmp21_ = g_settings_get_boolean (_tmp20_, "pause-when-idle");
				_tmp18_ = _tmp21_;
			} else {
				_tmp18_ = FALSE;
			}
			_tmp16_ = _tmp18_;
		}
		notify_start = _tmp16_;
		_tmp22_ = elapsed_tmp;
		_tmp23_ = state_duration_tmp;
		is_requested = _tmp22_ < _tmp23_;
		_tmp24_ = is_requested;
		is_completed = !_tmp24_;
		_tmp26_ = self->priv->pomodoro_end_timestamp;
		if (_tmp26_ > 0.0) {
			GDateTime* _tmp27_ = NULL;
			gchar* _tmp28_ = NULL;
			_tmp27_ = pomodoro_end_date;
			_tmp28_ = pomodoro_datetime_to_string (_tmp27_);
			_g_free0 (_tmp25_);
			_tmp25_ = _tmp28_;
		} else {
			gchar* _tmp29_ = NULL;
			_tmp29_ = g_strdup ("");
			_g_free0 (_tmp25_);
			_tmp25_ = _tmp29_;
		}
		_tmp30_ = g_strdup (_tmp25_);
		pomodoro_end_date_string = _tmp30_;
		_tmp31_ = state_date;
		_tmp32_ = pomodoro_datetime_to_string (_tmp31_);
		state_date_string = _tmp32_;
		_tmp33_ = self->priv->settings_state;
		_tmp34_ = self->priv->_session;
		g_settings_set_double (_tmp33_, "session", _tmp34_);
		_tmp35_ = self->priv->settings_state;
		_tmp36_ = pomodoro_timer_get_state (self);
		_tmp37_ = _tmp36_;
		_tmp38_ = pomodoro_state_to_string (_tmp37_);
		_tmp39_ = _tmp38_;
		g_settings_set_string (_tmp35_, "state", _tmp39_);
		_g_free0 (_tmp39_);
		_tmp40_ = self->priv->settings_state;
		_tmp41_ = state_date_string;
		g_settings_set_string (_tmp40_, "state-date", _tmp41_);
		_tmp42_ = self->priv->settings_state;
		_tmp43_ = self->priv->_state_duration;
		g_settings_set_double (_tmp42_, "state-duration", _tmp43_);
		_tmp44_ = self->priv->settings_state;
		_tmp45_ = pomodoro_end_date_string;
		g_settings_set_string (_tmp44_, "pomodoro-end-date", _tmp45_);
		g_signal_emit_by_name (self, "state-changed");
		_tmp46_ = self->priv->_state;
		if (_tmp46_ == POMODORO_STATE_POMODORO) {
			gboolean _tmp47_ = FALSE;
			_tmp47_ = is_requested;
			g_signal_emit_by_name (self, "pomodoro-start", _tmp47_);
		}
		_tmp49_ = state_tmp;
		if (_tmp49_ == POMODORO_STATE_PAUSE) {
			gboolean _tmp50_ = FALSE;
			_tmp50_ = notify_start;
			_tmp48_ = _tmp50_;
		} else {
			_tmp48_ = FALSE;
		}
		if (_tmp48_) {
			gboolean _tmp51_ = FALSE;
			_tmp51_ = is_requested;
			g_signal_emit_by_name (self, "notify-pomodoro-start", _tmp51_);
		}
		_tmp52_ = state_tmp;
		if (_tmp52_ == POMODORO_STATE_POMODORO) {
			gboolean _tmp53_ = FALSE;
			_tmp53_ = is_completed;
			g_signal_emit_by_name (self, "pomodoro-end", _tmp53_);
		}
		_tmp55_ = state_tmp;
		if (_tmp55_ == POMODORO_STATE_POMODORO) {
			PomodoroState _tmp56_ = 0;
			_tmp56_ = self->priv->_state;
			_tmp54_ = _tmp56_ == POMODORO_STATE_PAUSE;
		} else {
			_tmp54_ = FALSE;
		}
		if (_tmp54_) {
			gboolean _tmp57_ = FALSE;
			_tmp57_ = is_completed;
			g_signal_emit_by_name (self, "notify-pomodoro-end", _tmp57_);
		}
		_g_free0 (state_date_string);
		_g_free0 (pomodoro_end_date_string);
		_g_free0 (_tmp25_);
		_g_date_time_unref0 (pomodoro_end_date);
		_g_date_time_unref0 (state_date);
	}
	pomodoro_timer_update (self);
}


void pomodoro_timer_restore (PomodoroTimer* self) {
	PomodoroState state = 0;
	GSettings* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	PomodoroState _tmp3_ = 0;
	PomodoroState _tmp4_ = 0;
	gdouble state_duration = 0.0;
	GSettings* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	gchar* state_date = NULL;
	GSettings* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gdouble session = 0.0;
	GSettings* _tmp9_ = NULL;
	gdouble _tmp10_ = 0.0;
	gdouble current_timestamp = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble state_timestamp = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble pomodoro_end_timestamp = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	PomodoroState _tmp28_ = 0;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_ = 0.0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings_state;
	_tmp1_ = g_settings_get_string (_tmp0_, "state");
	_tmp2_ = _tmp1_;
	_tmp3_ = pomodoro_string_to_state (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	state = _tmp4_;
	_tmp5_ = self->priv->settings_state;
	_tmp6_ = g_settings_get_double (_tmp5_, "state-duration");
	state_duration = _tmp6_;
	_tmp7_ = self->priv->settings_state;
	_tmp8_ = g_settings_get_string (_tmp7_, "state-date");
	state_date = _tmp8_;
	_tmp9_ = self->priv->settings_state;
	_tmp10_ = g_settings_get_double (_tmp9_, "session");
	session = _tmp10_;
	_tmp11_ = pomodoro_get_real_time ();
	current_timestamp = _tmp11_;
	_tmp12_ = current_timestamp;
	state_timestamp = _tmp12_;
	pomodoro_end_timestamp = 0.0;
	{
		const gchar* _tmp13_ = NULL;
		_tmp13_ = state_date;
		if (g_strcmp0 (_tmp13_, "") != 0) {
			GDateTime* state_datetime = NULL;
			const gchar* _tmp14_ = NULL;
			GDateTime* _tmp15_ = NULL;
			GDateTime* _tmp16_ = NULL;
			gint64 _tmp17_ = 0LL;
			_tmp14_ = state_date;
			_tmp15_ = pomodoro_datetime_from_string (_tmp14_, &_inner_error_);
			state_datetime = _tmp15_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == POMODORO_DATE_TIME_ERROR) {
					goto __catch30_pomodoro_date_time_error;
				}
				_g_free0 (state_date);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp16_ = state_datetime;
			_tmp17_ = g_date_time_to_unix (_tmp16_);
			state_timestamp = (gdouble) _tmp17_;
			_g_date_time_unref0 (state_datetime);
		}
	}
	goto __finally30;
	__catch30_pomodoro_date_time_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("timer.vala:390: Could not restore time");
		_g_error_free0 (_error_);
		_g_free0 (state_date);
		return;
	}
	__finally30:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (state_date);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GDateTime* pomodoro_end_datetime = NULL;
		GSettings* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		GDateTime* _tmp21_ = NULL;
		GDateTime* _tmp22_ = NULL;
		GDateTime* _tmp23_ = NULL;
		gint64 _tmp24_ = 0LL;
		_tmp18_ = self->priv->settings_state;
		_tmp19_ = g_settings_get_string (_tmp18_, "pomodoro-end-date");
		_tmp20_ = _tmp19_;
		_tmp21_ = pomodoro_datetime_from_string (_tmp20_, &_inner_error_);
		_tmp22_ = _tmp21_;
		_g_free0 (_tmp20_);
		pomodoro_end_datetime = _tmp22_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == POMODORO_DATE_TIME_ERROR) {
				goto __catch31_pomodoro_date_time_error;
			}
			_g_free0 (state_date);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp23_ = pomodoro_end_datetime;
		_tmp24_ = g_date_time_to_unix (_tmp23_);
		pomodoro_end_timestamp = (gdouble) _tmp24_;
		_g_date_time_unref0 (pomodoro_end_datetime);
	}
	goto __finally31;
	__catch31_pomodoro_date_time_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (_error_);
	}
	__finally31:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (state_date);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_object_freeze_notify ((GObject*) self);
	self->priv->_state = POMODORO_STATE_NULL;
	self->priv->_elapsed = 0.0;
	pomodoro_timer_set_state_duration (self, 0.0);
	_tmp25_ = state_timestamp;
	pomodoro_timer_set_state_timestamp (self, _tmp25_);
	_tmp26_ = session;
	pomodoro_timer_set_session (self, _tmp26_);
	_tmp27_ = pomodoro_end_timestamp;
	self->priv->pomodoro_end_timestamp = _tmp27_;
	_tmp28_ = state;
	_tmp29_ = state_duration;
	_tmp30_ = state_timestamp;
	pomodoro_timer_set_state_full (self, _tmp28_, _tmp29_, _tmp30_);
	g_object_thaw_notify ((GObject*) self);
	_g_free0 (state_date);
}


void pomodoro_timer_start (PomodoroTimer* self) {
	gboolean _tmp0_ = FALSE;
	PomodoroState _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_state;
	if (_tmp1_ == POMODORO_STATE_NULL) {
		_tmp0_ = TRUE;
	} else {
		PomodoroState _tmp2_ = 0;
		_tmp2_ = self->priv->_state;
		_tmp0_ = _tmp2_ == POMODORO_STATE_IDLE;
	}
	if (_tmp0_) {
		pomodoro_timer_set_state (self, POMODORO_STATE_POMODORO);
	}
}


void pomodoro_timer_stop (PomodoroTimer* self) {
	g_return_if_fail (self != NULL);
	pomodoro_timer_set_state (self, POMODORO_STATE_NULL);
}


void pomodoro_timer_reset (PomodoroTimer* self) {
	gboolean is_running = FALSE;
	PomodoroState _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_state;
	is_running = _tmp0_ != POMODORO_STATE_NULL;
	g_object_freeze_notify ((GObject*) self);
	pomodoro_timer_set_session (self, 0.0);
	self->priv->pomodoro_end_timestamp = 0.0;
	pomodoro_timer_set_state (self, POMODORO_STATE_NULL);
	_tmp1_ = is_running;
	if (_tmp1_) {
		pomodoro_timer_set_state (self, POMODORO_STATE_POMODORO);
	}
	g_object_thaw_notify ((GObject*) self);
}


void pomodoro_timer_update (PomodoroTimer* self) {
	gdouble _tmp0_ = 0.0;
	PomodoroState _tmp1_ = 0;
	PomodoroState _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = pomodoro_get_real_time ();
	self->priv->current_timestamp = _tmp0_;
	g_object_notify ((GObject*) self, "elapsed");
	_tmp1_ = pomodoro_timer_get_state (self);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case POMODORO_STATE_IDLE:
		{
			break;
		}
		case POMODORO_STATE_PAUSE:
		{
			gdouble _tmp3_ = 0.0;
			gdouble _tmp4_ = 0.0;
			gdouble _tmp5_ = 0.0;
			_tmp3_ = pomodoro_timer_get_elapsed (self);
			_tmp4_ = _tmp3_;
			_tmp5_ = self->priv->_state_duration;
			if (_tmp4_ >= _tmp5_) {
				PomodoroState _tmp6_ = 0;
				GSettings* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				_tmp7_ = self->priv->settings;
				_tmp8_ = g_settings_get_boolean (_tmp7_, "pause-when-idle");
				if (_tmp8_) {
					_tmp6_ = POMODORO_STATE_IDLE;
				} else {
					_tmp6_ = POMODORO_STATE_POMODORO;
				}
				pomodoro_timer_set_state (self, _tmp6_);
			}
			break;
		}
		case POMODORO_STATE_POMODORO:
		{
			gdouble _tmp9_ = 0.0;
			gdouble _tmp10_ = 0.0;
			gdouble _tmp11_ = 0.0;
			_tmp9_ = pomodoro_timer_get_elapsed (self);
			_tmp10_ = _tmp9_;
			_tmp11_ = self->priv->_state_duration;
			if (_tmp10_ >= _tmp11_) {
				pomodoro_timer_set_state (self, POMODORO_STATE_PAUSE);
			}
			break;
		}
		default:
		break;
	}
	g_signal_emit_by_name (self, "updated");
}


static void _pomodoro_timer_on_idle_monitor_became_active_gnome_idle_monitor_watch_func (GnomeIdleMonitor* monitor, guint id, gpointer self) {
	pomodoro_timer_on_idle_monitor_became_active ((PomodoroTimer*) self, monitor);
}


void pomodoro_timer_enable_idle_monitor (PomodoroTimer* self) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->became_active_id;
	if (_tmp0_ == ((guint) 0)) {
		GnomeIdleMonitor* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		_tmp1_ = self->priv->idle_monitor;
		_tmp2_ = gnome_idle_monitor_add_user_active_watch (_tmp1_, _pomodoro_timer_on_idle_monitor_became_active_gnome_idle_monitor_watch_func, g_object_ref (self), g_object_unref);
		self->priv->became_active_id = _tmp2_;
	}
}


void pomodoro_timer_disable_idle_monitor (PomodoroTimer* self) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->became_active_id;
	if (_tmp0_ != ((guint) 0)) {
		GnomeIdleMonitor* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		_tmp1_ = self->priv->idle_monitor;
		_tmp2_ = self->priv->became_active_id;
		gnome_idle_monitor_remove_watch (_tmp1_, _tmp2_);
		self->priv->became_active_id = (guint) 0;
	}
}


static void pomodoro_timer_on_settings_changed (PomodoroTimer* self, GSettings* settings, const gchar* key) {
	gdouble state_duration = 0.0;
	gdouble _tmp0_ = 0.0;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GQuark _tmp4_ = 0U;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	static GQuark _tmp3_label2 = 0;
	static GQuark _tmp3_label3 = 0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (settings != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->_state_duration;
	state_duration = _tmp0_;
	_tmp1_ = key;
	_tmp2_ = _tmp1_;
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("pomodoro-duration")))) {
		switch (0) {
			default:
			{
				PomodoroState _tmp5_ = 0;
				PomodoroState _tmp6_ = 0;
				_tmp5_ = pomodoro_timer_get_state (self);
				_tmp6_ = _tmp5_;
				if (_tmp6_ == POMODORO_STATE_POMODORO) {
					GSettings* _tmp7_ = NULL;
					const gchar* _tmp8_ = NULL;
					gdouble _tmp9_ = 0.0;
					_tmp7_ = self->priv->settings;
					_tmp8_ = key;
					_tmp9_ = g_settings_get_double (_tmp7_, _tmp8_);
					state_duration = _tmp9_;
				}
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("short-break-duration")))) {
		switch (0) {
			default:
			{
				gboolean _tmp10_ = FALSE;
				PomodoroState _tmp11_ = 0;
				PomodoroState _tmp12_ = 0;
				_tmp11_ = pomodoro_timer_get_state (self);
				_tmp12_ = _tmp11_;
				if (_tmp12_ == POMODORO_STATE_PAUSE) {
					gboolean _tmp13_ = FALSE;
					_tmp13_ = self->priv->is_long_break;
					_tmp10_ = !_tmp13_;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					GSettings* _tmp14_ = NULL;
					const gchar* _tmp15_ = NULL;
					gdouble _tmp16_ = 0.0;
					_tmp14_ = self->priv->settings;
					_tmp15_ = key;
					_tmp16_ = g_settings_get_double (_tmp14_, _tmp15_);
					state_duration = _tmp16_;
				}
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("long-break-duration")))) {
		switch (0) {
			default:
			{
				gboolean _tmp17_ = FALSE;
				PomodoroState _tmp18_ = 0;
				PomodoroState _tmp19_ = 0;
				_tmp18_ = pomodoro_timer_get_state (self);
				_tmp19_ = _tmp18_;
				if (_tmp19_ == POMODORO_STATE_PAUSE) {
					gboolean _tmp20_ = FALSE;
					_tmp20_ = self->priv->is_long_break;
					_tmp17_ = _tmp20_;
				} else {
					_tmp17_ = FALSE;
				}
				if (_tmp17_) {
					GSettings* _tmp21_ = NULL;
					const gchar* _tmp22_ = NULL;
					gdouble _tmp23_ = 0.0;
					_tmp21_ = self->priv->settings;
					_tmp22_ = key;
					_tmp23_ = g_settings_get_double (_tmp21_, _tmp22_);
					state_duration = _tmp23_;
				}
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("long-break-interval")))) {
		switch (0) {
			default:
			{
				gdouble _tmp24_ = 0.0;
				GSettings* _tmp25_ = NULL;
				const gchar* _tmp26_ = NULL;
				gdouble _tmp27_ = 0.0;
				_tmp24_ = self->priv->_session_limit;
				_tmp25_ = self->priv->settings;
				_tmp26_ = key;
				_tmp27_ = g_settings_get_double (_tmp25_, _tmp26_);
				if (_tmp24_ != _tmp27_) {
					GSettings* _tmp28_ = NULL;
					const gchar* _tmp29_ = NULL;
					gdouble _tmp30_ = 0.0;
					_tmp28_ = self->priv->settings;
					_tmp29_ = key;
					_tmp30_ = g_settings_get_double (_tmp28_, _tmp29_);
					pomodoro_timer_set_session_limit (self, _tmp30_);
				}
				break;
			}
		}
	}
	_tmp31_ = state_duration;
	_tmp32_ = self->priv->_state_duration;
	if (_tmp31_ != _tmp32_) {
		gdouble _tmp33_ = 0.0;
		gdouble _tmp34_ = 0.0;
		gdouble _tmp35_ = 0.0;
		gdouble _tmp36_ = 0.0;
		_tmp33_ = state_duration;
		_tmp34_ = pomodoro_timer_get_elapsed (self);
		_tmp35_ = _tmp34_;
		_tmp36_ = MAX (_tmp33_, _tmp35_);
		pomodoro_timer_set_state_duration (self, _tmp36_);
		pomodoro_timer_update (self);
	}
}


static gboolean pomodoro_timer_on_timeout (PomodoroTimer* self) {
	gboolean result = FALSE;
	PomodoroState _tmp0_ = 0;
	PomodoroState _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = pomodoro_timer_get_state (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != POMODORO_STATE_NULL) {
		pomodoro_timer_update (self);
	}
	result = TRUE;
	return result;
}


static void pomodoro_timer_on_idle_monitor_became_active (PomodoroTimer* self, GnomeIdleMonitor* monitor) {
	PomodoroState _tmp0_ = 0;
	PomodoroState _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monitor != NULL);
	_tmp0_ = pomodoro_timer_get_state (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == POMODORO_STATE_IDLE) {
		gdouble _tmp2_ = 0.0;
		gdouble elapsed = 0.0;
		gdouble _tmp3_ = 0.0;
		gdouble _tmp4_ = 0.0;
		gdouble timestamp = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
		gdouble _tmp8_ = 0.0;
		_tmp2_ = pomodoro_get_real_time ();
		self->priv->current_timestamp = _tmp2_;
		_tmp3_ = self->priv->current_timestamp;
		_tmp4_ = self->priv->_state_timestamp;
		elapsed = _tmp3_ - _tmp4_;
		_tmp5_ = self->priv->current_timestamp;
		_tmp6_ = elapsed;
		_tmp7_ = CLAMP (_tmp6_, 0.0, 1.0);
		timestamp = _tmp5_ - _tmp7_;
		_tmp8_ = timestamp;
		pomodoro_timer_set_state_full (self, POMODORO_STATE_POMODORO, 0.0, _tmp8_);
	}
}


static void pomodoro_timer_real_dispose (GObject* base) {
	PomodoroTimer * self;
	guint _tmp0_ = 0U;
	self = (PomodoroTimer*) base;
	pomodoro_timer_disable_idle_monitor (self);
	_tmp0_ = self->priv->timeout_source;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->timeout_source;
		g_source_remove (_tmp1_);
		self->priv->timeout_source = (guint) 0;
	}
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = NULL;
	_g_object_unref0 (self->priv->settings_state);
	self->priv->settings_state = NULL;
	_g_object_unref0 (self->priv->idle_monitor);
	self->priv->idle_monitor = NULL;
	G_OBJECT_CLASS (pomodoro_timer_parent_class)->dispose (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
}


gdouble pomodoro_timer_get_elapsed (PomodoroTimer* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_elapsed;
	_tmp1_ = self->priv->current_timestamp;
	_tmp2_ = self->priv->_state_timestamp;
	result = (_tmp0_ + _tmp1_) - _tmp2_;
	return result;
}


void pomodoro_timer_set_elapsed (PomodoroTimer* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = self->priv->current_timestamp;
	_tmp2_ = self->priv->_state_timestamp;
	self->priv->_elapsed = (_tmp0_ - _tmp1_) + _tmp2_;
	g_object_notify ((GObject *) self, "elapsed");
}


PomodoroState pomodoro_timer_get_state (PomodoroTimer* self) {
	PomodoroState result;
	PomodoroState _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}


void pomodoro_timer_set_state (PomodoroTimer* self, PomodoroState value) {
	PomodoroState _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	pomodoro_timer_set_state_full (self, _tmp0_, (gdouble) 0, 0.0);
	g_object_notify ((GObject *) self, "state");
}


gdouble pomodoro_timer_get_state_duration (PomodoroTimer* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_state_duration;
	result = _tmp0_;
	return result;
}


void pomodoro_timer_set_state_duration (PomodoroTimer* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_state_duration = _tmp0_;
	g_object_notify ((GObject *) self, "state-duration");
}


gdouble pomodoro_timer_get_state_timestamp (PomodoroTimer* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_state_timestamp;
	result = _tmp0_;
	return result;
}


void pomodoro_timer_set_state_timestamp (PomodoroTimer* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_state_timestamp = _tmp0_;
	g_object_notify ((GObject *) self, "state-timestamp");
}


gdouble pomodoro_timer_get_session (PomodoroTimer* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_session;
	result = _tmp0_;
	return result;
}


void pomodoro_timer_set_session (PomodoroTimer* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_session = _tmp0_;
	g_object_notify ((GObject *) self, "session");
}


gdouble pomodoro_timer_get_session_limit (PomodoroTimer* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_session_limit;
	result = _tmp0_;
	return result;
}


void pomodoro_timer_set_session_limit (PomodoroTimer* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_session_limit = _tmp0_;
	g_object_notify ((GObject *) self, "session-limit");
}


static void pomodoro_timer_real_destroy (PomodoroTimer* self) {
	g_object_run_dispose ((GObject*) self);
}


static void pomodoro_timer_class_init (PomodoroTimerClass * klass) {
	pomodoro_timer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroTimerPrivate));
	((GObjectClass *) klass)->dispose = pomodoro_timer_real_dispose;
	((PomodoroTimerClass *) klass)->destroy = pomodoro_timer_real_destroy;
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_timer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_timer_set_property;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_timer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_ELAPSED, g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE, g_param_spec_enum ("state", "state", "state", POMODORO_TYPE_STATE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE_DURATION, g_param_spec_double ("state-duration", "state-duration", "state-duration", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE_TIMESTAMP, g_param_spec_double ("state-timestamp", "state-timestamp", "state-timestamp", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_SESSION, g_param_spec_double ("session", "session", "session", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_SESSION_LIMIT, g_param_spec_double ("session-limit", "session-limit", "session-limit", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("updated", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("state_changed", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("pomodoro_start", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("pomodoro_end", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("notify_pomodoro_start", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("notify_pomodoro_end", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("destroy", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroTimerClass, destroy), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void pomodoro_timer_instance_init (PomodoroTimer * self) {
	self->priv = POMODORO_TIMER_GET_PRIVATE (self);
}


static void pomodoro_timer_finalize (GObject* obj) {
	PomodoroTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_TIMER, PomodoroTimer);
	_g_object_unref0 (self->priv->idle_monitor);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->settings_state);
	G_OBJECT_CLASS (pomodoro_timer_parent_class)->finalize (obj);
}


GType pomodoro_timer_get_type (void) {
	static volatile gsize pomodoro_timer_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_timer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroTimer), 0, (GInstanceInitFunc) pomodoro_timer_instance_init, NULL };
		GType pomodoro_timer_type_id;
		pomodoro_timer_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroTimer", &g_define_type_info, 0);
		g_once_init_leave (&pomodoro_timer_type_id__volatile, pomodoro_timer_type_id);
	}
	return pomodoro_timer_type_id__volatile;
}


static void _vala_pomodoro_timer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PomodoroTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_TIMER, PomodoroTimer);
	switch (property_id) {
		case POMODORO_TIMER_ELAPSED:
		g_value_set_double (value, pomodoro_timer_get_elapsed (self));
		break;
		case POMODORO_TIMER_STATE:
		g_value_set_enum (value, pomodoro_timer_get_state (self));
		break;
		case POMODORO_TIMER_STATE_DURATION:
		g_value_set_double (value, pomodoro_timer_get_state_duration (self));
		break;
		case POMODORO_TIMER_STATE_TIMESTAMP:
		g_value_set_double (value, pomodoro_timer_get_state_timestamp (self));
		break;
		case POMODORO_TIMER_SESSION:
		g_value_set_double (value, pomodoro_timer_get_session (self));
		break;
		case POMODORO_TIMER_SESSION_LIMIT:
		g_value_set_double (value, pomodoro_timer_get_session_limit (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_pomodoro_timer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PomodoroTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_TIMER, PomodoroTimer);
	switch (property_id) {
		case POMODORO_TIMER_ELAPSED:
		pomodoro_timer_set_elapsed (self, g_value_get_double (value));
		break;
		case POMODORO_TIMER_STATE:
		pomodoro_timer_set_state (self, g_value_get_enum (value));
		break;
		case POMODORO_TIMER_STATE_DURATION:
		pomodoro_timer_set_state_duration (self, g_value_get_double (value));
		break;
		case POMODORO_TIMER_STATE_TIMESTAMP:
		pomodoro_timer_set_state_timestamp (self, g_value_get_double (value));
		break;
		case POMODORO_TIMER_SESSION:
		pomodoro_timer_set_session (self, g_value_get_double (value));
		break;
		case POMODORO_TIMER_SESSION_LIMIT:
		pomodoro_timer_set_session_limit (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



