/* utils.c generated by valac 0.26.1, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * Copyright (c) 2013 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	POMODORO_DATE_TIME_ERROR_PARSE
} PomodoroDateTimeError;
#define POMODORO_DATE_TIME_ERROR pomodoro_date_time_error_quark ()

extern gdouble pomodoro_global_timestamp;
gdouble pomodoro_global_timestamp = 0.0;

GQuark pomodoro_date_time_error_quark (void);
GDateTime* pomodoro_datetime_from_string (const gchar* date_string, GError** error);
gchar* pomodoro_datetime_to_string (GDateTime* datetime);
gchar* pomodoro_format_time (glong seconds);
void pomodoro_set_real_time (gdouble timestamp);
gdouble pomodoro_get_real_time (void);


GQuark pomodoro_date_time_error_quark (void) {
	return g_quark_from_static_string ("pomodoro_date_time_error-quark");
}


GDateTime* pomodoro_datetime_from_string (const gchar* date_string, GError** error) {
	GDateTime* result = NULL;
	GTimeVal timeval = {0};
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GTimeVal _tmp4_ = {0};
	GDateTime* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (date_string != NULL, NULL);
	g_get_current_time (&timeval);
	_tmp0_ = date_string;
	_tmp1_ = g_time_val_from_iso8601 (_tmp0_, &timeval);
	if (!_tmp1_) {
		const gchar* _tmp2_ = NULL;
		GError* _tmp3_ = NULL;
		_tmp2_ = date_string;
		_tmp3_ = g_error_new (POMODORO_DATE_TIME_ERROR, POMODORO_DATE_TIME_ERROR_PARSE, "Could not parse string '%s'", _tmp2_);
		_inner_error_ = _tmp3_;
		if (_inner_error_->domain == POMODORO_DATE_TIME_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = timeval;
	_tmp5_ = g_date_time_new_from_timeval_local (&_tmp4_);
	result = _tmp5_;
	return result;
}


gchar* pomodoro_datetime_to_string (GDateTime* datetime) {
	gchar* result = NULL;
	GTimeVal timeval = {0};
	gchar* date_string = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GDateTime* _tmp2_ = NULL;
	GTimeVal _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	g_return_val_if_fail (datetime != NULL, NULL);
	g_get_current_time (&timeval);
	_tmp0_ = datetime;
	_tmp1_ = g_date_time_to_utc (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp4_ = g_date_time_to_timeval (_tmp2_, &_tmp3_);
	timeval = _tmp3_;
	_tmp5_ = _tmp4_;
	_g_date_time_unref0 (_tmp2_);
	if (_tmp5_) {
		gchar* _tmp6_ = NULL;
		_tmp6_ = g_time_val_to_iso8601 (&timeval);
		_g_free0 (date_string);
		date_string = _tmp6_;
	} else {
		_g_free0 (date_string);
		date_string = NULL;
	}
	result = date_string;
	return result;
}


gchar* pomodoro_format_time (glong seconds) {
	gchar* result = NULL;
	glong minutes = 0L;
	glong _tmp0_ = 0L;
	glong hours = 0L;
	glong _tmp1_ = 0L;
	gchar* str = NULL;
	gchar* _tmp2_ = NULL;
	glong _tmp3_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp13_ = 0L;
	_tmp0_ = seconds;
	minutes = (_tmp0_ / 60) % 60;
	_tmp1_ = seconds;
	hours = _tmp1_ / 3600;
	_tmp2_ = g_strdup ("");
	str = _tmp2_;
	_tmp3_ = hours;
	if (_tmp3_ > ((glong) 0)) {
		glong _tmp4_ = 0L;
		const gchar* _tmp5_ = NULL;
		glong _tmp6_ = 0L;
		gchar* _tmp7_ = NULL;
		_tmp4_ = hours;
		_tmp5_ = ngettext ("%d hour", "%d hours", (gulong) _tmp4_);
		_tmp6_ = hours;
		_tmp7_ = g_strdup_printf (_tmp5_, _tmp6_);
		_g_free0 (str);
		str = _tmp7_;
	}
	_tmp9_ = minutes;
	if (_tmp9_ > ((glong) 0)) {
		const gchar* _tmp10_ = NULL;
		_tmp10_ = str;
		_tmp8_ = _tmp10_ != NULL;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		_tmp11_ = str;
		_tmp12_ = g_strconcat (_tmp11_, " ", NULL);
		_g_free0 (str);
		str = _tmp12_;
	}
	_tmp13_ = minutes;
	if (_tmp13_ > ((glong) 0)) {
		const gchar* _tmp14_ = NULL;
		glong _tmp15_ = 0L;
		const gchar* _tmp16_ = NULL;
		glong _tmp17_ = 0L;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		_tmp14_ = str;
		_tmp15_ = minutes;
		_tmp16_ = ngettext ("%d minute", "%d minutes", (gulong) _tmp15_);
		_tmp17_ = minutes;
		_tmp18_ = g_strdup_printf (_tmp16_, _tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strconcat (_tmp14_, _tmp19_, NULL);
		_g_free0 (str);
		str = _tmp20_;
		_g_free0 (_tmp19_);
	}
	result = str;
	return result;
}


void pomodoro_set_real_time (gdouble timestamp) {
	gdouble _tmp0_ = 0.0;
	_tmp0_ = timestamp;
	pomodoro_global_timestamp = _tmp0_;
}


gdouble pomodoro_get_real_time (void) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	_tmp1_ = pomodoro_global_timestamp;
	if (_tmp1_ > 0.0) {
		gdouble _tmp2_ = 0.0;
		_tmp2_ = pomodoro_global_timestamp;
		_tmp0_ = _tmp2_;
	} else {
		gint64 _tmp3_ = 0LL;
		_tmp3_ = g_get_real_time ();
		_tmp0_ = ((gdouble) _tmp3_) / 1000000.0;
	}
	result = _tmp0_;
	return result;
}



